// baltzo_zoneinfobinaryheader.cpp                                    -*-C++-*-
#include <baltzo_zoneinfobinaryheader.h>

#include <bsls_ident.h>
BSLS_IDENT_RCSID(baltzo_zoneinfobinaryheader_cpp,"$Id$ $CSID$")

#include <bsl_ostream.h>

#include <bslim_printer.h>

namespace BloombergLP {
namespace baltzo {

                         // --------------------------
                         // class ZoneinfoBinaryHeader
                         // --------------------------

// ACCESSORS

                        // Aspects

bsl::ostream& ZoneinfoBinaryHeader::print(bsl::ostream& stream,
                                          int           level,
                                          int           spacesPerLevel) const
{
    if (stream.bad()) {
        return stream;                                                // RETURN
    }

    bslim::Printer printer(&stream, level, spacesPerLevel);
    printer.start();
    printer.printAttribute("version",           static_cast<int>(d_version));
    printer.printAttribute("numIsGmt",          d_numIsGmt);
    printer.printAttribute("numIsStd",          d_numIsStd);
    printer.printAttribute("numLeaps",          d_numLeaps);
    printer.printAttribute("numTransitions",    d_numTransitions);
    printer.printAttribute("numLocalTimeTypes", d_numLocalTimeTypes);
    printer.printAttribute("abbrevDataSize",    d_abbrevDataSize);
    printer.end();

    return stream;
}

}  // close package namespace
}  // close enterprise namespace

// ----------------------------------------------------------------------------
// Copyright 2018 Bloomberg Finance L.P.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------- END-OF-FILE ----------------------------------
