// s_baltst_configschema.cpp         *DO NOT EDIT*         @generated -*-C++-*-

#include <bsls_ident.h>
BSLS_IDENT_RCSID(s_baltst_configschema_cpp, "$Id$ $CSID$")

#include <s_baltst_configschema.h>

namespace BloombergLP {
namespace s_baltst {

// CONSTANTS

const char ConfigSchema::TEXT[] =
"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\"\n"
"           xmlns:bdem=\"http://bloomberg.com/schemas/bdem\"\n"
"           bdem:package=\"s_baltst\"\n"
"           elementFormDefault=\"qualified\">\n"
"\n"
"  <!-- s_baltst_address.xsd -->\n"
"\n"
"  <xs:complexType name=\"Address\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"street\" type=\"xs:string\"/>\n"
"      <xs:element name=\"city\" type=\"xs:string\"/>\n"
"      <xs:element name=\"state\" type=\"xs:string\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_basicrecord.xsd -->\n"
"\n"
"  <xs:complexType name=\"BasicRecord\">\n"
"    <xs:annotation>\n"
"      <xs:documentation>\n"
"        A representative small record type\n"
"      </xs:documentation>\n"
"    </xs:annotation>\n"
"    <xs:sequence>\n"
"      <xs:element name=\"i1\" type=\"xs:int\"/>\n"
"      <xs:element name=\"i2\" type=\"xs:int\"/>\n"
"      <xs:element name=\"dt\" type=\"xs:dateTime\"/>\n"
"      <xs:element name=\"s\" type=\"xs:string\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_bigrecord.xsd -->\n"
"\n"
"  <xs:complexType name=\"BigRecord\">\n"
"    <xs:annotation>\n"
"      <xs:documentation>\n"
"        A bigger record containing an array of smaller records\n"
"      </xs:documentation>\n"
"    </xs:annotation>\n"
"    <xs:sequence>\n"
"      <xs:element name=\"name\" type=\"xs:string\"/>\n"
"      <xs:element name=\"array\"\n"
"                  type=\"BasicRecord\"\n"
"                  bdem:cppheader=\"s_baltst_basicrecord.h\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_customint.xsd -->\n"
"\n"
"  <xs:simpleType name=\"CustomInt\">\n"
"    <xs:restriction base=\"xs:int\">\n"
"      <xs:maxInclusive value=\"1000\"/>\n"
"    </xs:restriction>\n"
"  </xs:simpleType>\n"
"\n"
"  <!-- s_baltst_customizedstring.xsd -->\n"
"\n"
"  <xs:simpleType name=\"CustomizedString\">\n"
"    <xs:restriction base=\"xs:string\">\n"
"      <xs:maxLength value=\"25\"/>\n"
"    </xs:restriction>\n"
"  </xs:simpleType>\n"
"\n"
"  <!-- s_baltst_customstring.xsd -->\n"
"\n"
"  <xs:simpleType name=\"CustomString\">\n"
"    <xs:restriction base=\"xs:string\">\n"
"      <xs:maxLength value=\"8\"/>\n"
"    </xs:restriction>\n"
"  </xs:simpleType>\n"
"\n"
"  <!-- s_baltst_employee.xsd -->\n"
"\n"
"  <xs:complexType name=\"Employee\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"name\" type=\"xs:string\"/>\n"
"      <xs:element name=\"homeAddress\"\n"
"                  type=\"Address\"\n"
"                  bdem:cppheader='s_baltst_address.h'/>\n"
"      <xs:element name=\"age\" type=\"xs:int\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_enumerated.xsd -->\n"
"\n"
"  <xs:simpleType name=\"Enumerated\" bdem:preserveEnumOrder=\"1\">\n"
"    <xs:restriction base=\"xs:string\">\n"
"      <xs:enumeration value=\"NEW_YORK\"/>\n"
"      <xs:enumeration value=\"NEW_JERSEY\"/>\n"
"      <xs:enumeration value=\"LONDON\"/>\n"
"    </xs:restriction>\n"
"  </xs:simpleType>\n"
"\n"
"  <!-- s_baltst_featuretestmessage.xsd -->\n"
"\n"
"  <!-- s_baltst_voidsequence.xsd -->\n"
"\n"
"  <xs:complexType name='VoidSequence'>\n"
"    <xs:sequence/>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_unsignedsequence.xsd -->\n"
"\n"
"  <xs:complexType name='UnsignedSequence'>\n"
"    <xs:sequence>\n"
"      <xs:element name='element1' type='xs:unsignedInt'/>\n"
"      <xs:element name='element2' type='xs:unsignedShort'/>\n"
"      <xs:element name='element3' type='xs:unsignedLong'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_sequencewithanonymity.xsd -->\n"
"\n"
"  <!-- s_baltst_ratsnest.xsd -->\n"
"\n"
"  <xs:complexType name=\"Choice1\">\n"
"    <xs:choice>\n"
"      <xs:element name=\"selection1\" type=\"xs:int\"/>\n"
"      <xs:element name=\"selection2\" type=\"xs:double\"/>\n"
"      <xs:element name=\"selection3\" type=\"Sequence4\"/>\n"
"      <xs:element name=\"selection4\" type=\"Choice2\"/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Choice2\">\n"
"    <xs:choice>\n"
"      <xs:element name=\"selection1\" type=\"xs:boolean\"/>\n"
"      <xs:element name=\"selection2\" type=\"xs:string\"/>\n"
"      <xs:element name=\"selection3\" type=\"Choice1\"/>\n"
"      <xs:element name=\"selection4\" type=\"xs:unsignedInt\"/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Choice3\">\n"
"    <xs:choice>\n"
"      <xs:element name=\"selection1\" type=\"Sequence6\"/>\n"
"      <xs:element name=\"selection2\" type=\"xs:unsignedByte\"/>\n"
"      <xs:element name=\"selection3\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"/>\n"
"      <xs:element name=\"selection4\"\n"
"                  type=\"CustomInt\"\n"
"                  bdem:cppheader=\"s_baltst_customint.h\"/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Sequence1\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"element1\" type=\"Choice3\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element2\"\n"
"                  type=\"Choice1\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element3\" type=\"Choice2\"/>\n"
"      <xs:element name=\"element4\"\n"
"                  type=\"Choice1\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element5\"\n"
"                  type=\"Choice3\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Sequence2\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"element1\" type=\"CustomString\"/>\n"
"      <xs:element name=\"element2\" type=\"xs:unsignedByte\"/>\n"
"      <xs:element name=\"element3\" type=\"xs:dateTime\"/>\n"
"      <xs:element name=\"element4\" type=\"Choice1\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element5\" type=\"xs:double\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element6\"\n"
"                  type=\"xs:string\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element7\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Sequence3\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"element1\"\n"
"                  type=\"Enumerated\"\n"
"                  bdem:cppheader=\"s_baltst_enumerated.h\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element2\"\n"
"                  type=\"xs:string\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element3\" type=\"xs:boolean\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element4\" type=\"xs:string\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element5\" type=\"Sequence5\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element6\"\n"
"                  type=\"Enumerated\"\n"
"                  bdem:cppheader=\"s_baltst_enumerated.h\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Sequence4\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"element1\"\n"
"                  type=\"Sequence3\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element2\"\n"
"                  type=\"Choice1\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element3\" type=\"xs:hexBinary\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element4\" type=\"xs:int\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element5\" type=\"xs:dateTime\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element6\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"\n"
"                  minOccurs=\"0\"/>\n"
"      <xs:element name=\"element7\"\n"
"                  type=\"Enumerated\"\n"
"                  bdem:cppheader=\"s_baltst_enumerated.h\"\n"
"                  minOccurs=\"0\"/>\n"
"      <xs:element name=\"element8\" type=\"xs:boolean\"/>\n"
"      <xs:element name=\"element9\" type=\"xs:string\"/>\n"
"      <xs:element name=\"element10\" type=\"xs:double\"/>\n"
"      <xs:element name=\"element11\" type=\"xs:hexBinary\"/>\n"
"      <xs:element name=\"element12\" type=\"xs:int\"/>\n"
"      <xs:element name=\"element13\"\n"
"                  type=\"Enumerated\"\n"
"                  bdem:cppheader=\"s_baltst_enumerated.h\"/>\n"
"      <xs:element name=\"element14\"\n"
"                  type=\"xs:boolean\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element15\"\n"
"                  type=\"xs:double\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element16\"\n"
"                  type=\"xs:hexBinary\"\n"
"                  minOccurs=\"0\"/>\n"
"      <xs:element name=\"element17\"\n"
"                  type=\"xs:int\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element18\"\n"
"                  type=\"xs:dateTime\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element19\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Sequence5\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"element1\" type=\"Sequence3\"/>\n"
"      <xs:element name=\"element2\"\n"
"                  type=\"xs:boolean\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element3\"\n"
"                  type=\"xs:double\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element4\"\n"
"                  type=\"xs:hexBinary\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"/>\n"
"      <xs:element name=\"element5\"\n"
"                  type=\"xs:int\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element6\"\n"
"                  type=\"xs:dateTime\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element7\"\n"
"                  type=\"Sequence3\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"Sequence6\">\n"
"    <xs:sequence>\n"
"      <xs:element name=\"element1\" type=\"xs:unsignedByte\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element2\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"\n"
"                  minOccurs=\"0\"/>\n"
"      <xs:element name=\"element3\"\n"
"                  type=\"CustomInt\"\n"
"                  bdem:cppheader=\"s_baltst_customint.h\"\n"
"                  minOccurs=\"0\"/>\n"
"      <xs:element name=\"element4\" type=\"xs:unsignedInt\"/>\n"
"      <xs:element name=\"element5\" type=\"xs:unsignedByte\"/>\n"
"      <xs:element name=\"element6\"\n"
"                  type=\"CustomInt\"\n"
"                  bdem:cppheader=\"s_baltst_customint.h\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element7\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"/>\n"
"      <xs:element name=\"element8\"\n"
"                  type=\"CustomInt\"\n"
"                  bdem:cppheader=\"s_baltst_customint.h\"/>\n"
"      <xs:element name=\"element9\" type=\"xs:unsignedInt\" minOccurs=\"0\"/>\n"
"      <xs:element name=\"element10\"\n"
"                  type=\"xs:unsignedByte\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element11\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element12\"\n"
"                  type=\"xs:unsignedInt\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element13\"\n"
"                  type=\"xs:unsignedByte\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element14\"\n"
"                  type=\"CustomInt\"\n"
"                  bdem:cppheader=\"s_baltst_customint.h\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"      <xs:element name=\"element15\"\n"
"                  type=\"xs:unsignedInt\"\n"
"                  nillable=\"true\"\n"
"                  minOccurs=\"0\"\n"
"                  maxOccurs=\"unbounded\"/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='SequenceWithAnonymity'>\n"
"    <xs:sequence>\n"
"      <xs:choice>\n"
"        <xs:element name='selection1'\n"
"                    type='Sequence6'\n"
"                    bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"        <xs:element name='selection2' type='xs:unsignedByte'/>\n"
"        <xs:element name='selection3'\n"
"                    type='CustomString'\n"
"                    bdem:cppheader='s_baltst_customstring.h'/>\n"
"        <xs:element name='selection4'\n"
"                    type='CustomInt'\n"
"                    bdem:cppheader='s_baltst_customint.h'/>\n"
"      </xs:choice>\n"
"      <xs:choice>\n"
"        <xs:element name='selection5' type='xs:boolean'/>\n"
"        <xs:element name='selection6' type='xs:string'/>\n"
"      </xs:choice>\n"
"      <xs:choice minOccurs='0' maxOccurs='1'>\n"
"        <xs:element name='selection7'\n"
"                    type='Sequence4'\n"
"                    bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"        <xs:element name='selection8'\n"
"                    type='Choice2'\n"
"                    bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"      </xs:choice>\n"
"      <xs:element name='element4'\n"
"                  type='Sequence6'\n"
"                  bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name=\"FeatureTestMessage\">\n"
"    <xs:choice>\n"
"      <xs:element name=\"selection1\"\n"
"                  type=\"Sequence1\"\n"
"                  bdem:cppheader=\"s_baltst_ratsnest.h\"/>\n"
"      <xs:element name=\"selection2\" type=\"xs:hexBinary\"/>\n"
"      <xs:element name=\"selection3\"\n"
"                  type=\"Sequence2\"\n"
"                  bdem:cppheader=\"s_baltst_ratsnest.h\"/>\n"
"      <xs:element name=\"selection4\"\n"
"                  type=\"Sequence3\"\n"
"                  bdem:cppheader=\"s_baltst_ratsnest.h\"/>\n"
"      <xs:element name=\"selection5\" type=\"xs:dateTime\"/>\n"
"      <xs:element name=\"selection6\"\n"
"                  type=\"CustomString\"\n"
"                  bdem:cppheader=\"s_baltst_customstring.h\"/>\n"
"      <xs:element name=\"selection7\"\n"
"                  type=\"Enumerated\"\n"
"                  bdem:cppheader=\"s_baltst_enumerated.h\"/>\n"
"      <xs:element name=\"selection8\"\n"
"                  type=\"Choice3\"\n"
"                  bdem:cppheader=\"s_baltst_ratsnest.h\"/>\n"
"      <xs:element name=\"selection9\"\n"
"                  type=\"VoidSequence\"\n"
"                  bdem:cppheader=\"s_baltst_voidsequence.h\"/>\n"
"      <xs:element name=\"selection10\"\n"
"                  type=\"UnsignedSequence\"\n"
"                  bdem:cppheader=\"s_baltst_unsignedsequence.h\"/>\n"
"      <xs:element name=\"selection11\"\n"
"                  type=\"SequenceWithAnonymity\"\n"
"                  bdem:cppheader=\"s_baltst_sequencewithanonymity.h\"/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mychoice.xsd -->\n"
"\n"
"  <xs:complexType name='MyChoice'>\n"
"    <xs:choice>\n"
"      <xs:element name='selection1' type='xs:int'/>\n"
"      <xs:element name='selection2' type='xs:string'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_myenumeration.xsd -->\n"
"\n"
"  <xs:simpleType name='MyEnumeration' bdem:preserveEnumOrder='1'>\n"
"    <xs:restriction base='xs:string'>\n"
"      <xs:enumeration value='VALUE1'/>\n"
"      <xs:enumeration value='VALUE2'/>\n"
"    </xs:restriction>\n"
"  </xs:simpleType>\n"
"\n"
"  <!-- s_baltst_myenumerationwithfallback.xsd -->\n"
"\n"
"  <xs:simpleType name='MyEnumerationWithFallback'\n"
"                 bdem:preserveEnumOrder='true'\n"
"                 bdem:allowUnknownEnumerators='true'>\n"
"    <xs:restriction base='xs:string'>\n"
"      <xs:enumeration value='UNKNOWN' bdem:isFallbackEnumerator='true'/>\n"
"      <xs:enumeration value='VALUE1'/>\n"
"      <xs:enumeration value='VALUE2'/>\n"
"    </xs:restriction>\n"
"  </xs:simpleType>\n"
"\n"
"  <!-- s_baltst_mysequence.xsd -->\n"
"\n"
"  <xs:complexType name='MySequence'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int'/>\n"
"      <xs:element name='attribute2' type='xs:string'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithanonymouschoice.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithAnonymousChoice'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int' minOccurs='0'/>\n"
"      <xs:choice>\n"
"        <xs:element name='myChoice1' type='xs:int'/>\n"
"        <xs:element name='myChoice2' type='xs:string'/>\n"
"      </xs:choice>\n"
"      <xs:element name='attribute2' type='xs:string' minOccurs='0'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewitharray.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithArray'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int'/>\n"
"      <xs:element name='attribute2'\n"
"                  type='xs:string'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithattributes.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithAttributes'>\n"
"    <xs:sequence>\n"
"      <xs:element name='element1' type='xs:int' minOccurs='0'/>\n"
"      <xs:element name='element2' type='xs:string' minOccurs='0'/>\n"
"    </xs:sequence>\n"
"    <xs:attribute name='attribute1' type='xs:int' use='required'/>\n"
"    <xs:attribute name='attribute2' type='xs:string'/>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithchoice.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithChoice'>\n"
"    <xs:sequence>\n"
"      <xs:element name='mode' type='MySequenceWithChoiceChoice'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithChoiceChoice'>\n"
"    <xs:choice>\n"
"      <xs:element name='choiceA' type='xs:int'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithchoicearray.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithChoiceArray'>\n"
"    <xs:sequence>\n"
"      <xs:element name='choices'\n"
"                  type='MySequenceWithChoiceArrayChoice'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithChoiceArrayChoice'>\n"
"    <xs:choice>\n"
"      <xs:element name='choiceA' type='xs:int'/>\n"
"      <xs:element name='choiceB' type='xs:int'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithchoices.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithChoices'>\n"
"    <xs:sequence>\n"
"      <xs:element name='first'  type='MySequenceWithChoicesChoice1'/>\n"
"      <xs:element name='second' type='MySequenceWithChoicesChoice2'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithChoicesChoice1'>\n"
"    <xs:choice>\n"
"      <xs:element name='choiceA' type='xs:int'/>\n"
"      <xs:element name='choiceB' type='xs:int'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithChoicesChoice2'>\n"
"    <xs:choice>\n"
"      <xs:element name='choiceC' type='xs:int'/>\n"
"      <xs:element name='choiceD' type='xs:int'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithdecimalattribute.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithDecimalAttribute'>\n"
"    <xs:attribute name='attribute1' type='xs:decimal'/>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithdoubleattribute.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithDoubleAttribute'>\n"
"    <xs:attribute name='attribute1' type='xs:double'/>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithnillable.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithNillable'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int'/>\n"
"      <xs:element name='myNillable' type='xs:string' nillable='true'/>\n"
"      <xs:element name='attribute2' type='xs:string'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableBase64Binary'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:base64Binary' nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableHexBinary'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:hexBinary' nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableIntArray'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1'\n"
"                  type='xs:int'\n"
"                  maxOccurs='unbounded'\n"
"                  nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableIntList'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1'\n"
"                  type='MySequenceWithNillableIntList_List'\n"
"                  nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:simpleType name='MySequenceWithNillableIntList_List'>\n"
"    <xs:list itemType='xs:int'/>\n"
"  </xs:simpleType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableStringArray'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1'\n"
"                  type='xs:string'\n"
"                  maxOccurs='unbounded'\n"
"                  nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableIntSequenceArray'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1'\n"
"                  type='MySequenceWithNillableIntSequenceArray_Sequence'\n"
"                  maxOccurs='unbounded'\n"
"                  nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableIntSequenceArray_Sequence'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableStringList'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1'\n"
"                  type='MySequenceWithNillableStringList_List'\n"
"                  nillable='true'>\n"
"      </xs:element>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:simpleType name='MySequenceWithNillableStringList_List'>\n"
"    <xs:list itemType='xs:string'/>\n"
"  </xs:simpleType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableStringSequenceArray'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1'\n"
"                  type='MySequenceWithNillableStringSequenceArray_Sequence'\n"
"                  maxOccurs='unbounded'\n"
"                  nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='MySequenceWithNillableStringSequenceArray_Sequence'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:string'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithnillables.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithNillables'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int' nillable='true'/>\n"
"      <xs:element name='attribute2' type='xs:string' nillable='true'/>\n"
"      <xs:element name='attribute3'\n"
"                  type='MySequence'\n"
"                  bdem:cppheader='s_baltst_mysequence.h'\n"
"                  nillable='true'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithnullable.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithNullable'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int'/>\n"
"      <xs:element name='attribute2'\n"
"                  type='xs:string'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='1'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithnullables.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithNullables'>\n"
"    <xs:sequence>\n"
"      <xs:element name='attribute1' type='xs:int' minOccurs='0'/>\n"
"      <xs:element name='attribute2' type='xs:string' minOccurs='0'/>\n"
"      <xs:element name='attribute3'\n"
"                  type='MySequence'\n"
"                  bdem:cppheader='s_baltst_mysequence.h'\n"
"                  minOccurs='0'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_mysequencewithprecisiondecimalattribute.xsd -->\n"
"\n"
"  <xs:complexType name='MySequenceWithPrecisionDecimalAttribute'>\n"
"    <xs:attribute name='attribute1' type='xs:precisionDecimal'/>\n"
"  </xs:complexType>\n"
"\n"
" <!-- <xs:include schemaLocation='s_baltst_mysimplecontent.xsd'/> -->\n"
"\n"
"  <!-- s_baltst_rawdata.xsd -->\n"
"\n"
"  <xs:complexType name='RawData'>\n"
"    <xs:sequence>\n"
"      <xs:element name='charvec'\n"
"                  type='xs:byte'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'\n"
"                  bdem:formattingMode='default'\n"
"                  bdem:id='0'/>\n"
"      <xs:element name='ucharvec'\n"
"                  type='xs:unsignedByte'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'\n"
"                  bdem:formattingMode='default'\n"
"                  bdem:id='1'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_rawdataswitched.xsd -->\n"
"\n"
"  <xs:complexType name='RawDataSwitched'>\n"
"    <xs:sequence>\n"
"      <xs:element name='charvec'\n"
"                  type='xs:byte'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'\n"
"                  bdem:id='1'/>\n"
"      <xs:element name='ucharvec'\n"
"                  type='xs:unsignedByte'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'\n"
"                  bdem:id='0'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_rawdataunformatted.xsd -->\n"
"\n"
"  <xs:complexType name='RawDataUnformatted'>\n"
"    <xs:sequence>\n"
"      <xs:element name='charvec'\n"
"                  type='xs:byte'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'\n"
"                  bdem:id='0'/>\n"
"      <xs:element name='ucharvec'\n"
"                  type='xs:unsignedByte'\n"
"                  minOccurs='0'\n"
"                  maxOccurs='unbounded'\n"
"                  bdem:id='1'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_request.xsd -->\n"
"\n"
"  <!-- s_baltst_simplerequest.xsd -->\n"
"\n"
"  <xs:complexType name='SimpleRequest'>\n"
"    <xs:sequence>\n"
"      <xs:element name='data'           type='xs:string'/>\n"
"      <xs:element name='responseLength' type='xs:int'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <xs:complexType name='Request'>\n"
"    <xs:choice>\n"
"      <xs:element name='simpleRequest'\n"
"                  type='SimpleRequest'\n"
"                  bdem:cppheader='s_baltst_simplerequest.h'/>\n"
"      <xs:element name='featureRequest'\n"
"                  type='FeatureTestMessage'\n"
"                  bdem:cppheader='s_baltst_featuretestmessage.h'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_response.xsd -->\n"
"\n"
"  <xs:complexType name='Response'>\n"
"    <xs:choice>\n"
"      <xs:element name='responseData'    type='xs:string'/>\n"
"      <xs:element name='featureResponse'\n"
"                  type='FeatureTestMessage'\n"
"                  bdem:cppheader='s_baltst_featuretestmessage.h'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- s_baltst_sqrt.xsd -->\n"
"\n"
"  <xs:complexType name='Sqrt'>\n"
"    <xs:annotation>\n"
"      <xs:documentation>\n"
"          Simulate a square root request/response\n"
"      </xs:documentation>\n"
"    </xs:annotation>\n"
"    <xs:sequence>\n"
"      <xs:element name='value' type='xs:double'/>\n"
"    </xs:sequence>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- ./s_baltst_configschema.xsd -->\n"
"\n"
"  <!-- s_baltst_timingrequest.xsd -->\n"
"\n"
"  <xs:complexType name='TimingRequest'>\n"
"    <xs:annotation>\n"
"      <xs:documentation>\n"
"        A choice record representative of a typical request object.\n"
"      </xs:documentation>\n"
"    </xs:annotation>\n"
"    <xs:choice>\n"
"      <xs:element name='sqrt'\n"
"                  type='Sqrt'\n"
"                  bdem:cppheader='s_baltst_sqrt.h'/>\n"
"      <xs:element name='basic'\n"
"                  type='BasicRecord'\n"
"                  bdem:cppheader='s_baltst_basicrecord.h'/>\n"
"      <xs:element name='big'\n"
"                  type='BigRecord'\n"
"                  bdem:cppheader='s_baltst_bigrecord.h'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- ./s_baltst_configschema.xsd -->\n"
"\n"
"  <!-- s_baltst_topchoice.xsd -->\n"
"\n"
"  <xs:complexType name='Topchoice'>\n"
"    <xs:choice>\n"
"      <xs:element name='selection1'\n"
"                  type='Sequence1'\n"
"                  bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"      <xs:element name='selection2' type='xs:hexBinary'/>\n"
"      <xs:element name='selection3'\n"
"                  type='Sequence2'\n"
"                  bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"      <xs:element name='selection4'\n"
"                  type='Sequence3'\n"
"                  bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"      <xs:element name='selection5' type='xs:dateTime'/>\n"
"      <xs:element name='selection6'\n"
"                  type='CustomString'\n"
"                  bdem:cppheader='s_baltst_customstring.h'/>\n"
"      <xs:element name='selection7'\n"
"                  type='Enumerated'\n"
"                  bdem:cppheader='s_baltst_enumerated.h'/>\n"
"      <xs:element name='selection8'\n"
"                  type='Choice3'\n"
"                  bdem:cppheader='s_baltst_ratsnest.h'/>\n"
"    </xs:choice>\n"
"  </xs:complexType>\n"
"\n"
"  <!-- ./s_baltst_configschema.xsd -->\n"
"\n"
"  <xs:element name='Address'\n"
"              type='Address'/>\n"
"  <xs:element name='BasicRecord'\n"
"              type='BasicRecord'/>\n"
"  <xs:element name='BigRecord'\n"
"              type='BigRecord'/>\n"
"  <xs:element name='CustomInt'\n"
"              type='CustomInt'/>\n"
"  <xs:element name='CustomizedString'\n"
"              type='CustomizedString'/>\n"
"  <xs:element name='CustomString'\n"
"              type='CustomString'/>\n"
"  <xs:element name='Employee'\n"
"              type='Employee'/>\n"
"  <xs:element name='Enumerated'\n"
"              type='Enumerated'/>\n"
"  <xs:element name='FeatureTestMessage'\n"
"              type='FeatureTestMessage'/>\n"
"  <xs:element name='MyChoice'\n"
"              type='MyChoice'/>\n"
"  <xs:element name='MyEnumeration'\n"
"              type='MyEnumeration'/>\n"
"  <xs:element name='MyEnumerationWithFallback'\n"
"              type='MyEnumerationWithFallback'/>\n"
"  <xs:element name='MySequence'\n"
"              type='MySequence'/>\n"
"  <xs:element name='MySequenceWithAnonymousChoice'\n"
"              type='MySequenceWithAnonymousChoice'/>\n"
"  <xs:element name='MySequenceWithArray'\n"
"              type='MySequenceWithArray'/>\n"
"  <xs:element name='MySequenceWithAttributes'\n"
"              type='MySequenceWithAttributes'/>\n"
"  <xs:element name='MySequenceWithChoice'\n"
"              type='MySequenceWithChoice'/>\n"
"  <xs:element name='MySequenceWithChoiceArray'\n"
"              type='MySequenceWithChoiceArray'/>\n"
"  <xs:element name='MySequenceWithChoices'\n"
"              type='MySequenceWithChoices'/>\n"
"  <xs:element name='MySequenceWithDecimalAttribute'\n"
"              type='MySequenceWithDecimalAttribute'/>\n"
"  <xs:element name='MySequenceWithDoubleAttribute'\n"
"              type='MySequenceWithDoubleAttribute'/>\n"
"  <xs:element name='MySequenceWithNillable'\n"
"              type='MySequenceWithNillable'/>\n"
"  <xs:element name='MySequenceWithNillableBase64Binary'\n"
"              type='MySequenceWithNillableBase64Binary'/>\n"
"  <xs:element name='MySequenceWithNillableHexBinary'\n"
"              type='MySequenceWithNillableHexBinary'/>\n"
"  <xs:element name='MySequenceWithNillableIntArray'\n"
"              type='MySequenceWithNillableIntArray'/>\n"
"  <xs:element name='MySequenceWithNillableIntList'\n"
"              type='MySequenceWithNillableIntList'/>\n"
"  <xs:element name='MySequenceWithNillableIntSequenceArray'\n"
"              type='MySequenceWithNillableIntSequenceArray'/>\n"
"  <xs:element name='MySequenceWithNillableStringArray'\n"
"              type='MySequenceWithNillableStringArray'/>\n"
"  <xs:element name='MySequenceWithNillableStringList'\n"
"              type='MySequenceWithNillableStringList'/>\n"
"  <xs:element name='MySequenceWithNillableStringSequenceArray'\n"
"              type='MySequenceWithNillableStringSequenceArray'/>\n"
"  <xs:element name='MySequenceWithNillables'\n"
"              type='MySequenceWithNillables'/>\n"
"  <xs:element name='MySequenceWithNullable'\n"
"              type='MySequenceWithNullable'/>\n"
"  <xs:element name='MySequenceWithNullables'\n"
"              type='MySequenceWithNullables'/>\n"
"  <xs:element name='MySequenceWithPrecisionDecimalAttribute'\n"
"              type='MySequenceWithPrecisionDecimalAttribute'/>\n"
"  <!-- <xs:element name='MySimpleContent'\n"
"  type='MySimpleContent'/> -->\n"
"  <!-- The following types come from 's_baltst_ratsnest.xsd' -->\n"
"  <xs:element name='Choice1'\n"
"              type='Choice1'/>\n"
"  <xs:element name='Choice2'\n"
"              type='Choice2'/>\n"
"  <xs:element name='Choice3'\n"
"              type='Choice3'/>\n"
"  <xs:element name='Sequence1'\n"
"              type='Sequence1'/>\n"
"  <xs:element name='Sequence2'\n"
"              type='Sequence2'/>\n"
"  <xs:element name='Sequence3'\n"
"              type='Sequence3'/>\n"
"  <xs:element name='Sequence4'\n"
"              type='Sequence4'/>\n"
"  <xs:element name='Sequence5'\n"
"              type='Sequence5'/>\n"
"  <xs:element name='Sequence6'\n"
"              type='Sequence6'/>\n"
"  <!--                                                       -->\n"
"  <xs:element name='RawData'\n"
"              type='RawData'/>\n"
"  <xs:element name='RawDataSwitched'\n"
"              type='RawDataSwitched'/>\n"
"  <xs:element name='RawDataUnformatted'\n"
"              type='RawDataUnformatted'/>\n"
"  <xs:element name='Request'\n"
"              type='Request'/>\n"
"  <xs:element name='Response'\n"
"              type='Response'/>\n"
"  <xs:element name='SequenceWithAnonymity'\n"
"              type='SequenceWithAnonymity'/>\n"
"  <xs:element name='SimpleRequest'\n"
"              type='SimpleRequest'/>\n"
"  <xs:element name='Sqrt'\n"
"              type='Sqrt'/>\n"
"  <xs:element name='TimingRequest'\n"
"              type='TimingRequest'/>\n"
"  <xs:element name='Topchoice'\n"
"              type='Topchoice'/>\n"
"  <xs:element name='UnsignedSequence'\n"
"              type='UnsignedSequence'/>\n"
"  <xs:element name='VoidSequence'\n"
"              type='VoidSequence'/>\n"
"\n"
"</xs:schema>\n"
;

}  // close namespace s_baltst
}  // close namespace BloombergLP

// GENERATED BY @BLP_BAS_CODEGEN_VERSION@
// USING bas_codegen.pl --mode cfg --includeDir . --configSchema y s_baltst_configschema.xsd
// ----------------------------------------------------------------------------
// NOTICE:
//      Copyright 2022 Bloomberg Finance L.P. All rights reserved.
//      Property of Bloomberg Finance L.P. (BFLP)
//      This software is made available solely pursuant to the
//      terms of a BFLP license agreement which governs its use.
// ------------------------------- END-OF-FILE --------------------------------
