// s_baltst_featuretestmessageutil.cpp                                -*-C++-*-
#include <s_baltst_featuretestmessageutil.h>

#include <bsls_ident.h>
BSLS_IDENT_RCSID(s_baltst_featuretestmessageutil_cpp, "$Id$ $CSID$")

#include <bsls_platform.h>

namespace BloombergLP {
namespace s_baltst {

                       // -----------------------------
                       // struct FeatureTestMessageUtil
                       // -----------------------------

// CLASS DATA
const char *FeatureTestMessageUtil::s_COMPACT_JSON_MESSAGES[k_NUM_MESSAGES] = {
"{\"selection1\":{\"element3\":{\"selection1\":true}}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}},\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":{\"selection2\":\"\"},\"element5\":[{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}},{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}}]}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}},\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element3\":{\"selection2\":\"arbitrary string value\"},\"element4\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element5\":[{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}},{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}}]}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}},\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":{\"selection3\":{\"selection1\":-980123}},\"element4\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element5\":[{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}},{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}}]}}",
"{\"selection1\":{\"element1\":{\"selection2\":255},\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element3\":{\"selection3\":{\"selection1\":2}},\"element4\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element5\":[{\"selection2\":255},{\"selection2\":255}]}}",
"{\"selection1\":{\"element1\":{\"selection2\":0},\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":{\"selection3\":{\"selection2\":1.5}},\"element4\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element5\":[{\"selection2\":0},{\"selection2\":0}]}}",
"{\"selection1\":{\"element1\":{\"selection3\":\"custom\"},\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element3\":{\"selection3\":{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}},\"element4\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element5\":[{\"selection3\":\"custom\"},{\"selection3\":\"custom\"}]}}",
#if !defined(BSLS_PLATFORM_OS_WINDOWS)
// The following strings exceed the maximum string size on Windows
"{\"selection1\":{\"element1\":{\"selection4\":999},\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}},{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}}],\"element3\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}},\"element4\":[{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}},{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}}],\"element5\":[{\"selection4\":999},{\"selection4\":999}]}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999}},\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element3\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}},\"element4\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element5\":[{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999}},{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999}}]}}",
#endif
"{\"selection1\":{\"element2\":[{\"selection4\":{\"selection1\":true}},{\"selection4\":{\"selection1\":true}}],\"element3\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}},\"element4\":[{\"selection4\":{\"selection1\":true}},{\"selection4\":{\"selection1\":true}}]}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}},\"element2\":[{\"selection4\":{\"selection2\":\"\"}},{\"selection4\":{\"selection2\":\"\"}}],\"element3\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}}},\"element4\":[{\"selection4\":{\"selection2\":\"\"}},{\"selection4\":{\"selection2\":\"\"}}],\"element5\":[{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}},{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}}]}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}},\"element2\":[{\"selection4\":{\"selection2\":\"arbitrary string value\"}},{\"selection4\":{\"selection2\":\"arbitrary string value\"}}],\"element3\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}},\"element4\":[{\"selection4\":{\"selection2\":\"arbitrary string value\"}},{\"selection4\":{\"selection2\":\"arbitrary string value\"}}],\"element5\":[{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}},{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}}]}}",
"{\"selection1\":{\"element1\":{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}},\"element2\":[{\"selection4\":{\"selection3\":{\"selection1\":-980123}}},{\"selection4\":{\"selection3\":{\"selection1\":-980123}}}],\"element3\":{\"selection4\":3123123123},\"element4\":[{\"selection4\":{\"selection3\":{\"selection1\":-980123}}},{\"selection4\":{\"selection3\":{\"selection1\":-980123}}}],\"element5\":[{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}},{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}}]}}",
"{\"selection1\":{\"element1\":{\"selection2\":255},\"element2\":[{\"selection1\":-980123},{\"selection1\":-980123}],\"element3\":{\"selection1\":true},\"element4\":[{\"selection1\":-980123},{\"selection1\":-980123}],\"element5\":[{\"selection2\":255},{\"selection2\":255}]}}",
"{\"selection1\":{\"element1\":{\"selection2\":0},\"element3\":{\"selection2\":\"\"},\"element4\":[{\"selection1\":2},{\"selection1\":2}],\"element5\":[{\"selection2\":0},{\"selection2\":0}]}}",
"{\"selection2\":\"\\/wAB\"}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\"}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection1\":2},\"element5\":1.5}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection2\":1.5}}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},\"element5\":1.5}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},\"element5\":1.5}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}},\"element5\":1.5}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection4\":{\"selection1\":true}},\"element5\":1.5}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection4\":{\"selection2\":\"\"}}}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection4\":{\"selection2\":\"arbitrary string value\"}},\"element5\":1.5}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":255,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection4\":{\"selection3\":{\"selection1\":-980123}}}}}",
"{\"selection3\":{\"element1\":\"custom\",\"element2\":0,\"element3\":\"2012-08-18T13:25:00.000+00:00\",\"element4\":{\"selection1\":-980123},\"element5\":1.5}}",
"{\"selection4\":{}}",
"{\"selection4\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}}",
"{\"selection4\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}}",
"{\"selection4\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}}",
"{\"selection4\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}}",
"{\"selection5\":\"2012-08-18T13:25:00.000+00:00\"}",
"{\"selection6\":\"custom\"}",
"{\"selection7\":\"LONDON\"}",
"{\"selection8\":{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999}}}",
"{\"selection8\":{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}}}",
"{\"selection8\":{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}}}",
"{\"selection8\":{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}}}",
"{\"selection8\":{\"selection2\":255}}",
"{\"selection8\":{\"selection2\":0}}",
"{\"selection8\":{\"selection3\":\"custom\"}}",
"{\"selection8\":{\"selection4\":999}}",
"{\"selection11\":{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999},\"selection5\":true,\"element4\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999}}}",
"{\"selection11\":{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]},\"selection6\":\"\",\"selection7\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]},\"element4\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]},\"selection6\":\"arbitrary string value\",\"selection7\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]},\"element4\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]},\"selection5\":true,\"selection7\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]},\"element4\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}}}",
"{\"selection11\":{\"selection2\":255,\"selection6\":\"\",\"selection7\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]},\"element4\":{\"element1\":0,\"element4\":3123123123,\"element5\":255,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element10\":[0,0],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection2\":0,\"selection6\":\"arbitrary string value\",\"selection7\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]},\"element4\":{\"element1\":255,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[255,255],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection3\":\"custom\",\"selection5\":true,\"selection7\":{\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"},\"element4\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999,\"element13\":[255,255]}}}",
"{\"selection11\":{\"selection4\":999,\"selection6\":\"\",\"selection7\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}},{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]},\"element4\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999},\"selection6\":\"arbitrary string value\",\"selection8\":{\"selection1\":true},\"element4\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]},\"selection5\":true,\"selection8\":{\"selection2\":\"\"},\"element4\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999]}}}",
"{\"selection11\":{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]},\"selection6\":\"\",\"selection8\":{\"selection2\":\"arbitrary string value\"},\"element4\":{\"element1\":0,\"element4\":3123123123,\"element5\":255,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element10\":[0,0],\"element13\":[255,255],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]},\"selection6\":\"arbitrary string value\",\"selection8\":{\"selection3\":{\"selection1\":-980123}},\"element4\":{\"element1\":255,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[255,255],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection2\":255,\"selection5\":true,\"selection8\":{\"selection3\":{\"selection1\":2}},\"element4\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999}}}",
"{\"selection11\":{\"selection2\":0,\"selection6\":\"\",\"selection8\":{\"selection3\":{\"selection2\":1.5}},\"element4\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection3\":\"custom\",\"selection6\":\"arbitrary string value\",\"selection8\":{\"selection3\":{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}},\"element4\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection4\":999,\"selection5\":true,\"selection8\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}},\"element4\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]}}}",
"{\"selection11\":{\"selection1\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999},\"selection6\":\"\",\"selection8\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}},\"element4\":{\"element1\":0,\"element4\":3123123123,\"element5\":255,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element10\":[0,0],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection1\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[null,null]},\"selection6\":\"arbitrary string value\",\"selection8\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}},{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true,\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element3\":true},\"element5\":[2,2]}},\"element5\":[2,2]}}],\"element2\":[{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}},{\"selection3\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"}}],\"element3\":\"\\/wAB\",\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}},\"element4\":{\"element1\":255,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[255,255],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection1\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element13\":[255,255],\"element15\":[3123123123,3123123123]},\"selection5\":true,\"selection8\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}},{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"arbitrary string value\",\"arbitrary string value\"],\"element3\":true,\"element4\":\"arbitrary string value\",\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]},\"element2\":[null,null],\"element3\":[null,null],\"element5\":[null,null],\"element6\":[null,null]},\"element6\":[null,null]}],\"element2\":[{\"selection1\":2},{\"selection1\":2}],\"element3\":\"\\/wAB\",\"element4\":2,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[2,2],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}],\"element4\":2,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[2,2]}}},\"element4\":{\"element4\":3123123123,\"element5\":255,\"element7\":\"custom\",\"element8\":999,\"element13\":[255,255]}}}",
"{\"selection11\":{\"selection1\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999]},\"selection6\":\"\",\"selection8\":{\"selection3\":{\"selection3\":{\"element1\":[{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element5\":{\"element1\":{\"element1\":[\"LONDON\",\"LONDON\"],\"element2\":[\"\",\"\"],\"element3\":true,\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[null,null],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}},{\"selection3\":{\"element1\":[{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element5\":{\"element1\":{\"element2\":[\"\",\"\"],\"element4\":\"\",\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]},\"element2\":[true,true],\"element3\":[1.5,1.5],\"element5\":[-980123,-980123],\"element6\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"]},\"element6\":[\"LONDON\",\"LONDON\"]}],\"element2\":[{\"selection2\":1.5},{\"selection2\":1.5}],\"element4\":-980123,\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\",\"element17\":[-980123,-980123]}}],\"element3\":\"\\/wAB\",\"element4\":-980123,\"element5\":\"2012-08-18T13:25:00.000+00:00\",\"element6\":\"custom\",\"element7\":\"LONDON\",\"element8\":true,\"element9\":\"arbitrary string value\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":2,\"element13\":\"LONDON\",\"element14\":[true,true],\"element15\":[1.5,1.5],\"element17\":[-980123,-980123],\"element18\":[\"2012-08-18T13:25:00.000+00:00\",\"2012-08-18T13:25:00.000+00:00\"],\"element19\":[\"custom\",\"custom\"]}}},\"element4\":{\"element1\":0,\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element6\":[null,null],\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element10\":[0,0],\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[0,0],\"element14\":[999,999],\"element15\":[null,null]}}}",
"{\"selection11\":{\"selection2\":255,\"selection6\":\"arbitrary string value\",\"selection8\":{\"selection4\":3123123123},\"element4\":{\"element1\":255,\"element4\":3123123123,\"element5\":255,\"element6\":[999,999],\"element7\":\"custom\",\"element8\":999,\"element10\":[255,255],\"element15\":[3123123123,3123123123]}}}",
"{\"selection11\":{\"selection2\":0,\"selection5\":true,\"selection7\":{\"element8\":true,\"element9\":\"\",\"element10\":1.5,\"element11\":\"\\/wAB\",\"element12\":-980123,\"element13\":\"LONDON\"},\"element4\":{\"element2\":\"custom\",\"element3\":999,\"element4\":3123123123,\"element5\":0,\"element7\":\"custom\",\"element8\":999,\"element9\":3123123123,\"element11\":[\"custom\",\"custom\"],\"element12\":[3123123123,3123123123],\"element13\":[null,null],\"element14\":[999,999]}}}",
"{\"selection9\":{}}",
"{\"selection10\":{\"element1\":3000000000,\"element2\":32794,\"element3\":9223372036854775807}}"
};

const char *FeatureTestMessageUtil::s_PRETTY_JSON_MESSAGES[k_NUM_MESSAGES] = {
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element3\" : {\n"
    "      \"selection1\" : true\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element1\" : 0,\n"
    "        \"element2\" : \"custom\",\n"
    "        \"element3\" : 999,\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 0,\n"
    "        \"element6\" : [\n"
    "          null,\n"
    "          null\n"
    "        ],\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999,\n"
    "        \"element9\" : 3123123123,\n"
    "        \"element10\" : [\n"
    "          0,\n"
    "          0\n"
    "        ],\n"
    "        \"element11\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ],\n"
    "        \"element12\" : [\n"
    "          3123123123,\n"
    "          3123123123\n"
    "        ],\n"
    "        \"element13\" : [\n"
    "          null,\n"
    "          null\n"
    "        ],\n"
    "        \"element14\" : [\n"
    "          999,\n"
    "          999\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          null,\n"
    "          null\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection1\" : 2\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : 2\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection2\" : \"\"\n"
    "    },\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 0,\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element10\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 0,\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element10\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element1\" : 255,\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 255,\n"
    "        \"element6\" : [\n"
    "          999,\n"
    "          999\n"
    "        ],\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999,\n"
    "        \"element10\" : [\n"
    "          255,\n"
    "          255\n"
    "        ],\n"
    "        \"element13\" : [\n"
    "          255,\n"
    "          255\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          3123123123,\n"
    "          3123123123\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection2\" : 1.5\n"
    "      },\n"
    "      {\n"
    "        \"selection2\" : 1.5\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection2\" : \"arbitrary string value\"\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection2\" : 1.5\n"
    "      },\n"
    "      {\n"
    "        \"selection2\" : 1.5\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 255,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 255,\n"
    "          \"element6\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element10\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 255,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 255,\n"
    "          \"element6\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element10\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element2\" : \"custom\",\n"
    "        \"element3\" : 999,\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 0,\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999,\n"
    "        \"element9\" : 3123123123,\n"
    "        \"element11\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ],\n"
    "        \"element12\" : [\n"
    "          3123123123,\n"
    "          3123123123\n"
    "        ],\n"
    "        \"element13\" : [\n"
    "          0,\n"
    "          0\n"
    "        ],\n"
    "        \"element14\" : [\n"
    "          999,\n"
    "          999\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\"\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection1\" : -980123\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\"\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection2\" : 255\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            },\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : 2,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            },\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : 2,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection1\" : 2\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            },\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : 2,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            },\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : 2,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection2\" : 255\n"
    "      },\n"
    "      {\n"
    "        \"selection2\" : 255\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection2\" : 0\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            },\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : -980123,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            },\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : -980123,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection2\" : 1.5\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            },\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : -980123,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            },\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : -980123,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection2\" : 0\n"
    "      },\n"
    "      {\n"
    "        \"selection2\" : 0\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection3\" : \"custom\"\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\"\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection3\" : \"custom\"\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : \"custom\"\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
#if !defined(BSLS_PLATFORM_OS_WINDOWS)
// The following strings exceed the maximum string size on Windows
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection4\" : 999\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : 2,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : 2,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            },\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : 2,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : 2,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : 2,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection4\" : 999\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : 999\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 255,\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : -980123,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : -980123,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            },\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : -980123,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : -980123,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : -980123,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 255,\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 255,\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
#endif
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection1\" : true\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection1\" : true\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection1\" : true\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection1\" : true\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element1\" : 0,\n"
    "        \"element2\" : \"custom\",\n"
    "        \"element3\" : 999,\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 0,\n"
    "        \"element6\" : [\n"
    "          null,\n"
    "          null\n"
    "        ],\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999,\n"
    "        \"element9\" : 3123123123,\n"
    "        \"element10\" : [\n"
    "          0,\n"
    "          0\n"
    "        ],\n"
    "        \"element11\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ],\n"
    "        \"element12\" : [\n"
    "          3123123123,\n"
    "          3123123123\n"
    "        ],\n"
    "        \"element13\" : [\n"
    "          null,\n"
    "          null\n"
    "        ],\n"
    "        \"element14\" : [\n"
    "          999,\n"
    "          999\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          null,\n"
    "          null\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"\"\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : 2,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"\"\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 0,\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element10\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 0,\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element10\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element1\" : 255,\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 255,\n"
    "        \"element6\" : [\n"
    "          999,\n"
    "          999\n"
    "        ],\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999,\n"
    "        \"element10\" : [\n"
    "          255,\n"
    "          255\n"
    "        ],\n"
    "        \"element13\" : [\n"
    "          255,\n"
    "          255\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          3123123123,\n"
    "          3123123123\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"arbitrary string value\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"arbitrary string value\"\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : -980123,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"arbitrary string value\"\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection2\" : \"arbitrary string value\"\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 255,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 255,\n"
    "          \"element6\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element10\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element1\" : 255,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 255,\n"
    "          \"element6\" : [\n"
    "            999,\n"
    "            999\n"
    "          ],\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element10\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            255,\n"
    "            255\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection1\" : {\n"
    "        \"element2\" : \"custom\",\n"
    "        \"element3\" : 999,\n"
    "        \"element4\" : 3123123123,\n"
    "        \"element5\" : 0,\n"
    "        \"element7\" : \"custom\",\n"
    "        \"element8\" : 999,\n"
    "        \"element9\" : 3123123123,\n"
    "        \"element11\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ],\n"
    "        \"element12\" : [\n"
    "          3123123123,\n"
    "          3123123123\n"
    "        ],\n"
    "        \"element13\" : [\n"
    "          0,\n"
    "          0\n"
    "        ],\n"
    "        \"element14\" : [\n"
    "          999,\n"
    "          999\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection3\" : {\n"
    "            \"selection1\" : -980123\n"
    "          }\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection3\" : {\n"
    "            \"selection1\" : -980123\n"
    "          }\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection4\" : 3123123123\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection3\" : {\n"
    "            \"selection1\" : -980123\n"
    "          }\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection4\" : {\n"
    "          \"selection3\" : {\n"
    "            \"selection1\" : -980123\n"
    "          }\n"
    "        }\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : {\n"
    "          \"element2\" : \"custom\",\n"
    "          \"element3\" : 999,\n"
    "          \"element4\" : 3123123123,\n"
    "          \"element5\" : 0,\n"
    "          \"element7\" : \"custom\",\n"
    "          \"element8\" : 999,\n"
    "          \"element9\" : 3123123123,\n"
    "          \"element11\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ],\n"
    "          \"element12\" : [\n"
    "            3123123123,\n"
    "            3123123123\n"
    "          ],\n"
    "          \"element13\" : [\n"
    "            0,\n"
    "            0\n"
    "          ],\n"
    "          \"element14\" : [\n"
    "            999,\n"
    "            999\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection2\" : 255\n"
    "    },\n"
    "    \"element2\" : [\n"
    "      {\n"
    "        \"selection1\" : -980123\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : -980123\n"
    "      }\n"
    "    ],\n"
    "    \"element3\" : {\n"
    "      \"selection1\" : true\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection1\" : -980123\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : -980123\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection2\" : 255\n"
    "      },\n"
    "      {\n"
    "        \"selection2\" : 255\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection1\" : {\n"
    "    \"element1\" : {\n"
    "      \"selection2\" : 0\n"
    "    },\n"
    "    \"element3\" : {\n"
    "      \"selection2\" : \"\"\n"
    "    },\n"
    "    \"element4\" : [\n"
    "      {\n"
    "        \"selection1\" : 2\n"
    "      },\n"
    "      {\n"
    "        \"selection1\" : 2\n"
    "      }\n"
    "    ],\n"
    "    \"element5\" : [\n"
    "      {\n"
    "        \"selection2\" : 0\n"
    "      },\n"
    "      {\n"
    "        \"selection2\" : 0\n"
    "      }\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection2\" : \"\\/wAB\"\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\"\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection1\" : 2\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection2\" : 1.5\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection3\" : {\n"
    "        \"element8\" : true,\n"
    "        \"element9\" : \"\",\n"
    "        \"element10\" : 1.5,\n"
    "        \"element11\" : \"\\/wAB\",\n"
    "        \"element12\" : -980123,\n"
    "        \"element13\" : \"LONDON\"\n"
    "      }\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection3\" : {\n"
    "        \"element1\" : [\n"
    "          {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              \"arbitrary string value\",\n"
    "              \"arbitrary string value\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element4\" : \"arbitrary string value\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element5\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              \"arbitrary string value\",\n"
    "              \"arbitrary string value\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element4\" : \"arbitrary string value\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element5\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          }\n"
    "        ],\n"
    "        \"element2\" : [\n"
    "          {\n"
    "            \"selection1\" : 2\n"
    "          },\n"
    "          {\n"
    "            \"selection1\" : 2\n"
    "          }\n"
    "        ],\n"
    "        \"element3\" : \"\\/wAB\",\n"
    "        \"element4\" : 2,\n"
    "        \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"element6\" : \"custom\",\n"
    "        \"element7\" : \"LONDON\",\n"
    "        \"element8\" : true,\n"
    "        \"element9\" : \"arbitrary string value\",\n"
    "        \"element10\" : 1.5,\n"
    "        \"element11\" : \"\\/wAB\",\n"
    "        \"element12\" : 2,\n"
    "        \"element13\" : \"LONDON\",\n"
    "        \"element14\" : [\n"
    "          true,\n"
    "          true\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          1.5,\n"
    "          1.5\n"
    "        ],\n"
    "        \"element17\" : [\n"
    "          2,\n"
    "          2\n"
    "        ],\n"
    "        \"element18\" : [\n"
    "          \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"2012-08-18T13:25:00.000+00:00\"\n"
    "        ],\n"
    "        \"element19\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ]\n"
    "      }\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection3\" : {\n"
    "        \"element1\" : [\n"
    "          {\n"
    "            \"element2\" : [\n"
    "              \"\",\n"
    "              \"\"\n"
    "            ],\n"
    "            \"element4\" : \"\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    -980123,\n"
    "                    -980123\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                true,\n"
    "                true\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                1.5,\n"
    "                1.5\n"
    "              ],\n"
    "              \"element5\" : [\n"
    "                -980123,\n"
    "                -980123\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"2012-08-18T13:25:00.000+00:00\"\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ]\n"
    "          },\n"
    "          {\n"
    "            \"element2\" : [\n"
    "              \"\",\n"
    "              \"\"\n"
    "            ],\n"
    "            \"element4\" : \"\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    -980123,\n"
    "                    -980123\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                true,\n"
    "                true\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                1.5,\n"
    "                1.5\n"
    "              ],\n"
    "              \"element5\" : [\n"
    "                -980123,\n"
    "                -980123\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"2012-08-18T13:25:00.000+00:00\"\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ]\n"
    "          }\n"
    "        ],\n"
    "        \"element2\" : [\n"
    "          {\n"
    "            \"selection2\" : 1.5\n"
    "          },\n"
    "          {\n"
    "            \"selection2\" : 1.5\n"
    "          }\n"
    "        ],\n"
    "        \"element4\" : -980123,\n"
    "        \"element8\" : true,\n"
    "        \"element9\" : \"\",\n"
    "        \"element10\" : 1.5,\n"
    "        \"element11\" : \"\\/wAB\",\n"
    "        \"element12\" : -980123,\n"
    "        \"element13\" : \"LONDON\",\n"
    "        \"element17\" : [\n"
    "          -980123,\n"
    "          -980123\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection3\" : {\n"
    "        \"element1\" : [\n"
    "          {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element3\" : true\n"
    "                  },\n"
    "                  \"element5\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              \"element5\" : [\n"
    "                2,\n"
    "                2\n"
    "              ]\n"
    "            }\n"
    "          },\n"
    "          {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element3\" : true\n"
    "                  },\n"
    "                  \"element5\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              \"element5\" : [\n"
    "                2,\n"
    "                2\n"
    "              ]\n"
    "            }\n"
    "          }\n"
    "        ],\n"
    "        \"element2\" : [\n"
    "          {\n"
    "            \"selection3\" : {\n"
    "              \"element8\" : true,\n"
    "              \"element9\" : \"\",\n"
    "              \"element10\" : 1.5,\n"
    "              \"element11\" : \"\\/wAB\",\n"
    "              \"element12\" : -980123,\n"
    "              \"element13\" : \"LONDON\"\n"
    "            }\n"
    "          },\n"
    "          {\n"
    "            \"selection3\" : {\n"
    "              \"element8\" : true,\n"
    "              \"element9\" : \"\",\n"
    "              \"element10\" : 1.5,\n"
    "              \"element11\" : \"\\/wAB\",\n"
    "              \"element12\" : -980123,\n"
    "              \"element13\" : \"LONDON\"\n"
    "            }\n"
    "          }\n"
    "        ],\n"
    "        \"element3\" : \"\\/wAB\",\n"
    "        \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"element6\" : \"custom\",\n"
    "        \"element7\" : \"LONDON\",\n"
    "        \"element8\" : true,\n"
    "        \"element9\" : \"arbitrary string value\",\n"
    "        \"element10\" : 1.5,\n"
    "        \"element11\" : \"\\/wAB\",\n"
    "        \"element12\" : 2,\n"
    "        \"element13\" : \"LONDON\",\n"
    "        \"element14\" : [\n"
    "          true,\n"
    "          true\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          1.5,\n"
    "          1.5\n"
    "        ],\n"
    "        \"element18\" : [\n"
    "          \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"2012-08-18T13:25:00.000+00:00\"\n"
    "        ],\n"
    "        \"element19\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ]\n"
    "      }\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection3\" : {\n"
    "        \"element1\" : [\n"
    "          {\n"
    "            \"element2\" : [\n"
    "              \"arbitrary string value\",\n"
    "              \"arbitrary string value\"\n"
    "            ],\n"
    "            \"element4\" : \"arbitrary string value\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          {\n"
    "            \"element2\" : [\n"
    "              \"arbitrary string value\",\n"
    "              \"arbitrary string value\"\n"
    "            ],\n"
    "            \"element4\" : \"arbitrary string value\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          }\n"
    "        ],\n"
    "        \"element2\" : [\n"
    "          {\n"
    "            \"selection3\" : {\n"
    "              \"element1\" : [\n"
    "                {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                }\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                {\n"
    "                  \"selection1\" : 2\n"
    "                },\n"
    "                {\n"
    "                  \"selection1\" : 2\n"
    "                }\n"
    "              ],\n"
    "              \"element3\" : \"\\/wAB\",\n"
    "              \"element4\" : 2,\n"
    "              \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"element6\" : \"custom\",\n"
    "              \"element7\" : \"LONDON\",\n"
    "              \"element8\" : true,\n"
    "              \"element9\" : \"arbitrary string value\",\n"
    "              \"element10\" : 1.5,\n"
    "              \"element11\" : \"\\/wAB\",\n"
    "              \"element12\" : 2,\n"
    "              \"element13\" : \"LONDON\",\n"
    "              \"element14\" : [\n"
    "                true,\n"
    "                true\n"
    "              ],\n"
    "              \"element15\" : [\n"
    "                1.5,\n"
    "                1.5\n"
    "              ],\n"
    "              \"element17\" : [\n"
    "                2,\n"
    "                2\n"
    "              ],\n"
    "              \"element18\" : [\n"
    "                \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"2012-08-18T13:25:00.000+00:00\"\n"
    "              ],\n"
    "              \"element19\" : [\n"
    "                \"custom\",\n"
    "                \"custom\"\n"
    "              ]\n"
    "            }\n"
    "          },\n"
    "          {\n"
    "            \"selection3\" : {\n"
    "              \"element1\" : [\n"
    "                {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                }\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                {\n"
    "                  \"selection1\" : 2\n"
    "                },\n"
    "                {\n"
    "                  \"selection1\" : 2\n"
    "                }\n"
    "              ],\n"
    "              \"element3\" : \"\\/wAB\",\n"
    "              \"element4\" : 2,\n"
    "              \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"element6\" : \"custom\",\n"
    "              \"element7\" : \"LONDON\",\n"
    "              \"element8\" : true,\n"
    "              \"element9\" : \"arbitrary string value\",\n"
    "              \"element10\" : 1.5,\n"
    "              \"element11\" : \"\\/wAB\",\n"
    "              \"element12\" : 2,\n"
    "              \"element13\" : \"LONDON\",\n"
    "              \"element14\" : [\n"
    "                true,\n"
    "                true\n"
    "              ],\n"
    "              \"element15\" : [\n"
    "                1.5,\n"
    "                1.5\n"
    "              ],\n"
    "              \"element17\" : [\n"
    "                2,\n"
    "                2\n"
    "              ],\n"
    "              \"element18\" : [\n"
    "                \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"2012-08-18T13:25:00.000+00:00\"\n"
    "              ],\n"
    "              \"element19\" : [\n"
    "                \"custom\",\n"
    "                \"custom\"\n"
    "              ]\n"
    "            }\n"
    "          }\n"
    "        ],\n"
    "        \"element4\" : 2,\n"
    "        \"element8\" : true,\n"
    "        \"element9\" : \"\",\n"
    "        \"element10\" : 1.5,\n"
    "        \"element11\" : \"\\/wAB\",\n"
    "        \"element12\" : -980123,\n"
    "        \"element13\" : \"LONDON\",\n"
    "        \"element17\" : [\n"
    "          2,\n"
    "          2\n"
    "        ]\n"
    "      }\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection3\" : {\n"
    "        \"element1\" : [\n"
    "          {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              \"\",\n"
    "              \"\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element4\" : \"\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                true,\n"
    "                true\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                1.5,\n"
    "                1.5\n"
    "              ],\n"
    "              \"element5\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"2012-08-18T13:25:00.000+00:00\"\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ]\n"
    "          },\n"
    "          {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              \"\",\n"
    "              \"\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element4\" : \"\",\n"
    "            \"element5\" : {\n"
    "              \"element1\" : {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              },\n"
    "              \"element2\" : [\n"
    "                true,\n"
    "                true\n"
    "              ],\n"
    "              \"element3\" : [\n"
    "                1.5,\n"
    "                1.5\n"
    "              ],\n"
    "              \"element5\" : [\n"
    "                null,\n"
    "                null\n"
    "              ],\n"
    "              \"element6\" : [\n"
    "                \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"2012-08-18T13:25:00.000+00:00\"\n"
    "              ]\n"
    "            },\n"
    "            \"element6\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ]\n"
    "          }\n"
    "        ],\n"
    "        \"element2\" : [\n"
    "          {\n"
    "            \"selection3\" : {\n"
    "              \"element1\" : [\n"
    "                {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element2\" : [\n"
    "                            \"\",\n"
    "                            \"\"\n"
    "                          ],\n"
    "                          \"element4\" : \"\",\n"
    "                          \"element6\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          true,\n"
    "                          true\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          1.5,\n"
    "                          1.5\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          -980123,\n"
    "                          -980123\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          \"2012-08-18T13:25:00.000+00:00\",\n"
    "                          \"2012-08-18T13:25:00.000+00:00\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element2\" : [\n"
    "                            \"\",\n"
    "                            \"\"\n"
    "                          ],\n"
    "                          \"element4\" : \"\",\n"
    "                          \"element6\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          true,\n"
    "                          true\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          1.5,\n"
    "                          1.5\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          -980123,\n"
    "                          -980123\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          \"2012-08-18T13:25:00.000+00:00\",\n"
    "                          \"2012-08-18T13:25:00.000+00:00\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                }\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                {\n"
    "                  \"selection2\" : 1.5\n"
    "                },\n"
    "                {\n"
    "                  \"selection2\" : 1.5\n"
    "                }\n"
    "              ],\n"
    "              \"element4\" : -980123,\n"
    "              \"element8\" : true,\n"
    "              \"element9\" : \"\",\n"
    "              \"element10\" : 1.5,\n"
    "              \"element11\" : \"\\/wAB\",\n"
    "              \"element12\" : -980123,\n"
    "              \"element13\" : \"LONDON\",\n"
    "              \"element17\" : [\n"
    "                -980123,\n"
    "                -980123\n"
    "              ]\n"
    "            }\n"
    "          },\n"
    "          {\n"
    "            \"selection3\" : {\n"
    "              \"element1\" : [\n"
    "                {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element2\" : [\n"
    "                            \"\",\n"
    "                            \"\"\n"
    "                          ],\n"
    "                          \"element4\" : \"\",\n"
    "                          \"element6\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          true,\n"
    "                          true\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          1.5,\n"
    "                          1.5\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          -980123,\n"
    "                          -980123\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          \"2012-08-18T13:25:00.000+00:00\",\n"
    "                          \"2012-08-18T13:25:00.000+00:00\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element2\" : [\n"
    "                            \"\",\n"
    "                            \"\"\n"
    "                          ],\n"
    "                          \"element4\" : \"\",\n"
    "                          \"element6\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          true,\n"
    "                          true\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          1.5,\n"
    "                          1.5\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          -980123,\n"
    "                          -980123\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          \"2012-08-18T13:25:00.000+00:00\",\n"
    "                          \"2012-08-18T13:25:00.000+00:00\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                }\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                {\n"
    "                  \"selection2\" : 1.5\n"
    "                },\n"
    "                {\n"
    "                  \"selection2\" : 1.5\n"
    "                }\n"
    "              ],\n"
    "              \"element4\" : -980123,\n"
    "              \"element8\" : true,\n"
    "              \"element9\" : \"\",\n"
    "              \"element10\" : 1.5,\n"
    "              \"element11\" : \"\\/wAB\",\n"
    "              \"element12\" : -980123,\n"
    "              \"element13\" : \"LONDON\",\n"
    "              \"element17\" : [\n"
    "                -980123,\n"
    "                -980123\n"
    "              ]\n"
    "            }\n"
    "          }\n"
    "        ],\n"
    "        \"element3\" : \"\\/wAB\",\n"
    "        \"element4\" : -980123,\n"
    "        \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"element6\" : \"custom\",\n"
    "        \"element7\" : \"LONDON\",\n"
    "        \"element8\" : true,\n"
    "        \"element9\" : \"arbitrary string value\",\n"
    "        \"element10\" : 1.5,\n"
    "        \"element11\" : \"\\/wAB\",\n"
    "        \"element12\" : 2,\n"
    "        \"element13\" : \"LONDON\",\n"
    "        \"element14\" : [\n"
    "          true,\n"
    "          true\n"
    "        ],\n"
    "        \"element15\" : [\n"
    "          1.5,\n"
    "          1.5\n"
    "        ],\n"
    "        \"element17\" : [\n"
    "          -980123,\n"
    "          -980123\n"
    "        ],\n"
    "        \"element18\" : [\n"
    "          \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"2012-08-18T13:25:00.000+00:00\"\n"
    "        ],\n"
    "        \"element19\" : [\n"
    "          \"custom\",\n"
    "          \"custom\"\n"
    "        ]\n"
    "      }\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection4\" : {\n"
    "        \"selection1\" : true\n"
    "      }\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection4\" : {\n"
    "        \"selection2\" : \"\"\n"
    "      }\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection4\" : {\n"
    "        \"selection2\" : \"arbitrary string value\"\n"
    "      }\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 255,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection4\" : {\n"
    "        \"selection3\" : {\n"
    "          \"selection1\" : -980123\n"
    "        }\n"
    "      }\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection3\" : {\n"
    "    \"element1\" : \"custom\",\n"
    "    \"element2\" : 0,\n"
    "    \"element3\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "    \"element4\" : {\n"
    "      \"selection1\" : -980123\n"
    "    },\n"
    "    \"element5\" : 1.5\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection4\" : {\n"
    "\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection4\" : {\n"
    "    \"element1\" : [\n"
    "      \"LONDON\",\n"
    "      \"LONDON\"\n"
    "    ],\n"
    "    \"element2\" : [\n"
    "      \"arbitrary string value\",\n"
    "      \"arbitrary string value\"\n"
    "    ],\n"
    "    \"element3\" : true,\n"
    "    \"element4\" : \"arbitrary string value\",\n"
    "    \"element5\" : {\n"
    "      \"element1\" : {\n"
    "        \"element1\" : [\n"
    "          \"LONDON\",\n"
    "          \"LONDON\"\n"
    "        ],\n"
    "        \"element2\" : [\n"
    "          \"arbitrary string value\",\n"
    "          \"arbitrary string value\"\n"
    "        ],\n"
    "        \"element3\" : true,\n"
    "        \"element4\" : \"arbitrary string value\",\n"
    "        \"element5\" : {\n"
    "          \"element1\" : {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              \"arbitrary string value\",\n"
    "              \"arbitrary string value\"\n"
    "            ],\n"
    "            \"element3\" : true,\n"
    "            \"element4\" : \"arbitrary string value\",\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element2\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element3\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element5\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        },\n"
    "        \"element6\" : [\n"
    "          null,\n"
    "          null\n"
    "        ]\n"
    "      },\n"
    "      \"element2\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element3\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element5\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    },\n"
    "    \"element6\" : [\n"
    "      null,\n"
    "      null\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection4\" : {\n"
    "    \"element2\" : [\n"
    "      \"\",\n"
    "      \"\"\n"
    "    ],\n"
    "    \"element4\" : \"\",\n"
    "    \"element5\" : {\n"
    "      \"element1\" : {\n"
    "        \"element2\" : [\n"
    "          \"\",\n"
    "          \"\"\n"
    "        ],\n"
    "        \"element4\" : \"\",\n"
    "        \"element5\" : {\n"
    "          \"element1\" : {\n"
    "            \"element2\" : [\n"
    "              \"\",\n"
    "              \"\"\n"
    "            ],\n"
    "            \"element4\" : \"\",\n"
    "            \"element6\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ]\n"
    "          },\n"
    "          \"element2\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element3\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element5\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element6\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ]\n"
    "        },\n"
    "        \"element6\" : [\n"
    "          \"LONDON\",\n"
    "          \"LONDON\"\n"
    "        ]\n"
    "      },\n"
    "      \"element2\" : [\n"
    "        true,\n"
    "        true\n"
    "      ],\n"
    "      \"element3\" : [\n"
    "        1.5,\n"
    "        1.5\n"
    "      ],\n"
    "      \"element5\" : [\n"
    "        -980123,\n"
    "        -980123\n"
    "      ],\n"
    "      \"element6\" : [\n"
    "        \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"2012-08-18T13:25:00.000+00:00\"\n"
    "      ]\n"
    "    },\n"
    "    \"element6\" : [\n"
    "      \"LONDON\",\n"
    "      \"LONDON\"\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection4\" : {\n"
    "    \"element1\" : [\n"
    "      \"LONDON\",\n"
    "      \"LONDON\"\n"
    "    ],\n"
    "    \"element3\" : true,\n"
    "    \"element5\" : {\n"
    "      \"element1\" : {\n"
    "        \"element1\" : [\n"
    "          \"LONDON\",\n"
    "          \"LONDON\"\n"
    "        ],\n"
    "        \"element3\" : true,\n"
    "        \"element5\" : {\n"
    "          \"element1\" : {\n"
    "            \"element1\" : [\n"
    "              \"LONDON\",\n"
    "              \"LONDON\"\n"
    "            ],\n"
    "            \"element3\" : true\n"
    "          },\n"
    "          \"element5\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      },\n"
    "      \"element5\" : [\n"
    "        2,\n"
    "        2\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection4\" : {\n"
    "    \"element2\" : [\n"
    "      \"arbitrary string value\",\n"
    "      \"arbitrary string value\"\n"
    "    ],\n"
    "    \"element4\" : \"arbitrary string value\",\n"
    "    \"element5\" : {\n"
    "      \"element1\" : {\n"
    "        \"element2\" : [\n"
    "          \"arbitrary string value\",\n"
    "          \"arbitrary string value\"\n"
    "        ],\n"
    "        \"element4\" : \"arbitrary string value\",\n"
    "        \"element5\" : {\n"
    "          \"element1\" : {\n"
    "            \"element2\" : [\n"
    "              \"arbitrary string value\",\n"
    "              \"arbitrary string value\"\n"
    "            ],\n"
    "            \"element4\" : \"arbitrary string value\",\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element2\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element3\" : [\n"
    "            null,\n"
    "            null\n"
    "          ],\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        },\n"
    "        \"element6\" : [\n"
    "          null,\n"
    "          null\n"
    "        ]\n"
    "      },\n"
    "      \"element2\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element3\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    },\n"
    "    \"element6\" : [\n"
    "      null,\n"
    "      null\n"
    "    ]\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection5\" : \"2012-08-18T13:25:00.000+00:00\"\n"
    "}\n",
    "{\n"
    "  \"selection6\" : \"custom\"\n"
    "}\n",
    "{\n"
    "  \"selection7\" : \"LONDON\"\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection2\" : 255\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection2\" : 0\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection3\" : \"custom\"\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection8\" : {\n"
    "    \"selection4\" : 999\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999\n"
    "    },\n"
    "    \"selection5\" : true,\n"
    "    \"element4\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    },\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection7\" : {\n"
    "      \"element1\" : [\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            \"arbitrary string value\",\n"
    "            \"arbitrary string value\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element4\" : \"arbitrary string value\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        },\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            \"arbitrary string value\",\n"
    "            \"arbitrary string value\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element4\" : \"arbitrary string value\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      ],\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection1\" : 2\n"
    "        },\n"
    "        {\n"
    "          \"selection1\" : 2\n"
    "        }\n"
    "      ],\n"
    "      \"element3\" : \"\\/wAB\",\n"
    "      \"element4\" : 2,\n"
    "      \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "      \"element6\" : \"custom\",\n"
    "      \"element7\" : \"LONDON\",\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"arbitrary string value\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : 2,\n"
    "      \"element13\" : \"LONDON\",\n"
    "      \"element14\" : [\n"
    "        true,\n"
    "        true\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        1.5,\n"
    "        1.5\n"
    "      ],\n"
    "      \"element17\" : [\n"
    "        2,\n"
    "        2\n"
    "      ],\n"
    "      \"element18\" : [\n"
    "        \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"2012-08-18T13:25:00.000+00:00\"\n"
    "      ],\n"
    "      \"element19\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ]\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    },\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection7\" : {\n"
    "      \"element1\" : [\n"
    "        {\n"
    "          \"element2\" : [\n"
    "            \"\",\n"
    "            \"\"\n"
    "          ],\n"
    "          \"element4\" : \"\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              -980123,\n"
    "              -980123\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ]\n"
    "        },\n"
    "        {\n"
    "          \"element2\" : [\n"
    "            \"\",\n"
    "            \"\"\n"
    "          ],\n"
    "          \"element4\" : \"\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              -980123,\n"
    "              -980123\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ]\n"
    "        }\n"
    "      ],\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection2\" : 1.5\n"
    "        },\n"
    "        {\n"
    "          \"selection2\" : 1.5\n"
    "        }\n"
    "      ],\n"
    "      \"element4\" : -980123,\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : -980123,\n"
    "      \"element13\" : \"LONDON\",\n"
    "      \"element17\" : [\n"
    "        -980123,\n"
    "        -980123\n"
    "      ]\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    },\n"
    "    \"selection5\" : true,\n"
    "    \"selection7\" : {\n"
    "      \"element1\" : [\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            \"element5\" : [\n"
    "              2,\n"
    "              2\n"
    "            ]\n"
    "          }\n"
    "        },\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            \"element5\" : [\n"
    "              2,\n"
    "              2\n"
    "            ]\n"
    "          }\n"
    "        }\n"
    "      ],\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : -980123,\n"
    "            \"element13\" : \"LONDON\"\n"
    "          }\n"
    "        },\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : -980123,\n"
    "            \"element13\" : \"LONDON\"\n"
    "          }\n"
    "        }\n"
    "      ],\n"
    "      \"element3\" : \"\\/wAB\",\n"
    "      \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "      \"element6\" : \"custom\",\n"
    "      \"element7\" : \"LONDON\",\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"arbitrary string value\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : 2,\n"
    "      \"element13\" : \"LONDON\",\n"
    "      \"element14\" : [\n"
    "        true,\n"
    "        true\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        1.5,\n"
    "        1.5\n"
    "      ],\n"
    "      \"element18\" : [\n"
    "        \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"2012-08-18T13:25:00.000+00:00\"\n"
    "      ],\n"
    "      \"element19\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ]\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection2\" : 255,\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection7\" : {\n"
    "      \"element1\" : [\n"
    "        {\n"
    "          \"element2\" : [\n"
    "            \"arbitrary string value\",\n"
    "            \"arbitrary string value\"\n"
    "          ],\n"
    "          \"element4\" : \"arbitrary string value\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        },\n"
    "        {\n"
    "          \"element2\" : [\n"
    "            \"arbitrary string value\",\n"
    "            \"arbitrary string value\"\n"
    "          ],\n"
    "          \"element4\" : \"arbitrary string value\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      ],\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection1\" : 2\n"
    "              },\n"
    "              {\n"
    "                \"selection1\" : 2\n"
    "              }\n"
    "            ],\n"
    "            \"element3\" : \"\\/wAB\",\n"
    "            \"element4\" : 2,\n"
    "            \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"element6\" : \"custom\",\n"
    "            \"element7\" : \"LONDON\",\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"arbitrary string value\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : 2,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element14\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element15\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element17\" : [\n"
    "              2,\n"
    "              2\n"
    "            ],\n"
    "            \"element18\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ],\n"
    "            \"element19\" : [\n"
    "              \"custom\",\n"
    "              \"custom\"\n"
    "            ]\n"
    "          }\n"
    "        },\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection1\" : 2\n"
    "              },\n"
    "              {\n"
    "                \"selection1\" : 2\n"
    "              }\n"
    "            ],\n"
    "            \"element3\" : \"\\/wAB\",\n"
    "            \"element4\" : 2,\n"
    "            \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"element6\" : \"custom\",\n"
    "            \"element7\" : \"LONDON\",\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"arbitrary string value\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : 2,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element14\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element15\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element17\" : [\n"
    "              2,\n"
    "              2\n"
    "            ],\n"
    "            \"element18\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ],\n"
    "            \"element19\" : [\n"
    "              \"custom\",\n"
    "              \"custom\"\n"
    "            ]\n"
    "          }\n"
    "        }\n"
    "      ],\n"
    "      \"element4\" : 2,\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : -980123,\n"
    "      \"element13\" : \"LONDON\",\n"
    "      \"element17\" : [\n"
    "        2,\n"
    "        2\n"
    "      ]\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection2\" : 0,\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection7\" : {\n"
    "      \"element1\" : [\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            \"\",\n"
    "            \"\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element4\" : \"\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ]\n"
    "        },\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            \"\",\n"
    "            \"\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element4\" : \"\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ]\n"
    "        }\n"
    "      ],\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    -980123,\n"
    "                    -980123\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              },\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    -980123,\n"
    "                    -980123\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection2\" : 1.5\n"
    "              },\n"
    "              {\n"
    "                \"selection2\" : 1.5\n"
    "              }\n"
    "            ],\n"
    "            \"element4\" : -980123,\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : -980123,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element17\" : [\n"
    "              -980123,\n"
    "              -980123\n"
    "            ]\n"
    "          }\n"
    "        },\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    -980123,\n"
    "                    -980123\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              },\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"\",\n"
    "                  \"\"\n"
    "                ],\n"
    "                \"element4\" : \"\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element5\" : [\n"
    "                    -980123,\n"
    "                    -980123\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ]\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection2\" : 1.5\n"
    "              },\n"
    "              {\n"
    "                \"selection2\" : 1.5\n"
    "              }\n"
    "            ],\n"
    "            \"element4\" : -980123,\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : -980123,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element17\" : [\n"
    "              -980123,\n"
    "              -980123\n"
    "            ]\n"
    "          }\n"
    "        }\n"
    "      ],\n"
    "      \"element3\" : \"\\/wAB\",\n"
    "      \"element4\" : -980123,\n"
    "      \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "      \"element6\" : \"custom\",\n"
    "      \"element7\" : \"LONDON\",\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"arbitrary string value\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : 2,\n"
    "      \"element13\" : \"LONDON\",\n"
    "      \"element14\" : [\n"
    "        true,\n"
    "        true\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        1.5,\n"
    "        1.5\n"
    "      ],\n"
    "      \"element17\" : [\n"
    "        -980123,\n"
    "        -980123\n"
    "      ],\n"
    "      \"element18\" : [\n"
    "        \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"2012-08-18T13:25:00.000+00:00\"\n"
    "      ],\n"
    "      \"element19\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ]\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection3\" : \"custom\",\n"
    "    \"selection5\" : true,\n"
    "    \"selection7\" : {\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element3\" : true\n"
    "                      },\n"
    "                      \"element5\" : [\n"
    "                        2,\n"
    "                        2\n"
    "                      ]\n"
    "                    }\n"
    "                  },\n"
    "                  \"element5\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element3\" : true\n"
    "                      },\n"
    "                      \"element5\" : [\n"
    "                        2,\n"
    "                        2\n"
    "                      ]\n"
    "                    }\n"
    "                  },\n"
    "                  \"element5\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ]\n"
    "                }\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : -980123,\n"
    "                  \"element13\" : \"LONDON\"\n"
    "                }\n"
    "              },\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : -980123,\n"
    "                  \"element13\" : \"LONDON\"\n"
    "                }\n"
    "              }\n"
    "            ],\n"
    "            \"element3\" : \"\\/wAB\",\n"
    "            \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"element6\" : \"custom\",\n"
    "            \"element7\" : \"LONDON\",\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"arbitrary string value\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : 2,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element14\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element15\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element18\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ],\n"
    "            \"element19\" : [\n"
    "              \"custom\",\n"
    "              \"custom\"\n"
    "            ]\n"
    "          }\n"
    "        },\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element3\" : true\n"
    "                      },\n"
    "                      \"element5\" : [\n"
    "                        2,\n"
    "                        2\n"
    "                      ]\n"
    "                    }\n"
    "                  },\n"
    "                  \"element5\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              {\n"
    "                \"element1\" : [\n"
    "                  \"LONDON\",\n"
    "                  \"LONDON\"\n"
    "                ],\n"
    "                \"element3\" : true,\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element3\" : true\n"
    "                      },\n"
    "                      \"element5\" : [\n"
    "                        2,\n"
    "                        2\n"
    "                      ]\n"
    "                    }\n"
    "                  },\n"
    "                  \"element5\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ]\n"
    "                }\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : -980123,\n"
    "                  \"element13\" : \"LONDON\"\n"
    "                }\n"
    "              },\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : -980123,\n"
    "                  \"element13\" : \"LONDON\"\n"
    "                }\n"
    "              }\n"
    "            ],\n"
    "            \"element3\" : \"\\/wAB\",\n"
    "            \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"element6\" : \"custom\",\n"
    "            \"element7\" : \"LONDON\",\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"arbitrary string value\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : 2,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element14\" : [\n"
    "              true,\n"
    "              true\n"
    "            ],\n"
    "            \"element15\" : [\n"
    "              1.5,\n"
    "              1.5\n"
    "            ],\n"
    "            \"element18\" : [\n"
    "              \"2012-08-18T13:25:00.000+00:00\",\n"
    "              \"2012-08-18T13:25:00.000+00:00\"\n"
    "            ],\n"
    "            \"element19\" : [\n"
    "              \"custom\",\n"
    "              \"custom\"\n"
    "            ]\n"
    "          }\n"
    "        }\n"
    "      ],\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : -980123,\n"
    "      \"element13\" : \"LONDON\"\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection4\" : 999,\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection7\" : {\n"
    "      \"element1\" : [\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            \"arbitrary string value\",\n"
    "            \"arbitrary string value\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element4\" : \"arbitrary string value\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        },\n"
    "        {\n"
    "          \"element1\" : [\n"
    "            \"LONDON\",\n"
    "            \"LONDON\"\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            \"arbitrary string value\",\n"
    "            \"arbitrary string value\"\n"
    "          ],\n"
    "          \"element3\" : true,\n"
    "          \"element4\" : \"arbitrary string value\",\n"
    "          \"element5\" : {\n"
    "            \"element1\" : {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            \"element2\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element3\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element5\" : [\n"
    "              null,\n"
    "              null\n"
    "            ],\n"
    "            \"element6\" : [\n"
    "              null,\n"
    "              null\n"
    "            ]\n"
    "          },\n"
    "          \"element6\" : [\n"
    "            null,\n"
    "            null\n"
    "          ]\n"
    "        }\n"
    "      ],\n"
    "      \"element2\" : [\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element1\" : [\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    },\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element3\" : \"\\/wAB\",\n"
    "                  \"element4\" : 2,\n"
    "                  \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"element6\" : \"custom\",\n"
    "                  \"element7\" : \"LONDON\",\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"arbitrary string value\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : 2,\n"
    "                  \"element13\" : \"LONDON\",\n"
    "                  \"element14\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element15\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element17\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ],\n"
    "                  \"element18\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ],\n"
    "                  \"element19\" : [\n"
    "                    \"custom\",\n"
    "                    \"custom\"\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element1\" : [\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    },\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element3\" : \"\\/wAB\",\n"
    "                  \"element4\" : 2,\n"
    "                  \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"element6\" : \"custom\",\n"
    "                  \"element7\" : \"LONDON\",\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"arbitrary string value\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : 2,\n"
    "                  \"element13\" : \"LONDON\",\n"
    "                  \"element14\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element15\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element17\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ],\n"
    "                  \"element18\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ],\n"
    "                  \"element19\" : [\n"
    "                    \"custom\",\n"
    "                    \"custom\"\n"
    "                  ]\n"
    "                }\n"
    "              }\n"
    "            ],\n"
    "            \"element4\" : 2,\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : -980123,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element17\" : [\n"
    "              2,\n"
    "              2\n"
    "            ]\n"
    "          }\n"
    "        },\n"
    "        {\n"
    "          \"selection3\" : {\n"
    "            \"element1\" : [\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              {\n"
    "                \"element2\" : [\n"
    "                  \"arbitrary string value\",\n"
    "                  \"arbitrary string value\"\n"
    "                ],\n"
    "                \"element4\" : \"arbitrary string value\",\n"
    "                \"element5\" : {\n"
    "                  \"element1\" : {\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element2\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element3\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ],\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              }\n"
    "            ],\n"
    "            \"element2\" : [\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element1\" : [\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    },\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element3\" : \"\\/wAB\",\n"
    "                  \"element4\" : 2,\n"
    "                  \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"element6\" : \"custom\",\n"
    "                  \"element7\" : \"LONDON\",\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"arbitrary string value\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : 2,\n"
    "                  \"element13\" : \"LONDON\",\n"
    "                  \"element14\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element15\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element17\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ],\n"
    "                  \"element18\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ],\n"
    "                  \"element19\" : [\n"
    "                    \"custom\",\n"
    "                    \"custom\"\n"
    "                  ]\n"
    "                }\n"
    "              },\n"
    "              {\n"
    "                \"selection3\" : {\n"
    "                  \"element1\" : [\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element5\" : {\n"
    "                        \"element1\" : {\n"
    "                          \"element1\" : [\n"
    "                            \"LONDON\",\n"
    "                            \"LONDON\"\n"
    "                          ],\n"
    "                          \"element2\" : [\n"
    "                            \"arbitrary string value\",\n"
    "                            \"arbitrary string value\"\n"
    "                          ],\n"
    "                          \"element3\" : true,\n"
    "                          \"element4\" : \"arbitrary string value\",\n"
    "                          \"element5\" : {\n"
    "                            \"element1\" : {\n"
    "                              \"element1\" : [\n"
    "                                \"LONDON\",\n"
    "                                \"LONDON\"\n"
    "                              ],\n"
    "                              \"element2\" : [\n"
    "                                \"arbitrary string value\",\n"
    "                                \"arbitrary string value\"\n"
    "                              ],\n"
    "                              \"element3\" : true,\n"
    "                              \"element4\" : \"arbitrary string value\",\n"
    "                              \"element6\" : [\n"
    "                                null,\n"
    "                                null\n"
    "                              ]\n"
    "                            },\n"
    "                            \"element2\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element3\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element5\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ],\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element2\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element3\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element5\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ],\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    },\n"
    "                    {\n"
    "                      \"selection1\" : 2\n"
    "                    }\n"
    "                  ],\n"
    "                  \"element3\" : \"\\/wAB\",\n"
    "                  \"element4\" : 2,\n"
    "                  \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"element6\" : \"custom\",\n"
    "                  \"element7\" : \"LONDON\",\n"
    "                  \"element8\" : true,\n"
    "                  \"element9\" : \"arbitrary string value\",\n"
    "                  \"element10\" : 1.5,\n"
    "                  \"element11\" : \"\\/wAB\",\n"
    "                  \"element12\" : 2,\n"
    "                  \"element13\" : \"LONDON\",\n"
    "                  \"element14\" : [\n"
    "                    true,\n"
    "                    true\n"
    "                  ],\n"
    "                  \"element15\" : [\n"
    "                    1.5,\n"
    "                    1.5\n"
    "                  ],\n"
    "                  \"element17\" : [\n"
    "                    2,\n"
    "                    2\n"
    "                  ],\n"
    "                  \"element18\" : [\n"
    "                    \"2012-08-18T13:25:00.000+00:00\",\n"
    "                    \"2012-08-18T13:25:00.000+00:00\"\n"
    "                  ],\n"
    "                  \"element19\" : [\n"
    "                    \"custom\",\n"
    "                    \"custom\"\n"
    "                  ]\n"
    "                }\n"
    "              }\n"
    "            ],\n"
    "            \"element4\" : 2,\n"
    "            \"element8\" : true,\n"
    "            \"element9\" : \"\",\n"
    "            \"element10\" : 1.5,\n"
    "            \"element11\" : \"\\/wAB\",\n"
    "            \"element12\" : -980123,\n"
    "            \"element13\" : \"LONDON\",\n"
    "            \"element17\" : [\n"
    "              2,\n"
    "              2\n"
    "            ]\n"
    "          }\n"
    "        }\n"
    "      ],\n"
    "      \"element3\" : \"\\/wAB\",\n"
    "      \"element4\" : 2,\n"
    "      \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "      \"element6\" : \"custom\",\n"
    "      \"element7\" : \"LONDON\",\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"arbitrary string value\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : 2,\n"
    "      \"element13\" : \"LONDON\",\n"
    "      \"element14\" : [\n"
    "        true,\n"
    "        true\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        1.5,\n"
    "        1.5\n"
    "      ],\n"
    "      \"element17\" : [\n"
    "        2,\n"
    "        2\n"
    "      ],\n"
    "      \"element18\" : [\n"
    "        \"2012-08-18T13:25:00.000+00:00\",\n"
    "        \"2012-08-18T13:25:00.000+00:00\"\n"
    "      ],\n"
    "      \"element19\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ]\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999\n"
    "    },\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection8\" : {\n"
    "      \"selection1\" : true\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    },\n"
    "    \"selection5\" : true,\n"
    "    \"selection8\" : {\n"
    "      \"selection2\" : \"\"\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    },\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection8\" : {\n"
    "      \"selection2\" : \"arbitrary string value\"\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    },\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection1\" : -980123\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection2\" : 255,\n"
    "    \"selection5\" : true,\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection1\" : 2\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection2\" : 0,\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection2\" : 1.5\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection3\" : \"custom\",\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\"\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection4\" : 999,\n"
    "    \"selection5\" : true,\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            },\n"
    "            {\n"
    "              \"selection1\" : 2\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : 2,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999\n"
    "    },\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      -980123,\n"
    "                      -980123\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            },\n"
    "            {\n"
    "              \"selection2\" : 1.5\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : -980123,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    },\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element3\" : true\n"
    "                    },\n"
    "                    \"element5\" : [\n"
    "                      2,\n"
    "                      2\n"
    "                    ]\n"
    "                  }\n"
    "                },\n"
    "                \"element5\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\"\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    },\n"
    "    \"selection5\" : true,\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element2\" : [\n"
    "                \"arbitrary string value\",\n"
    "                \"arbitrary string value\"\n"
    "              ],\n"
    "              \"element4\" : \"arbitrary string value\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element2\" : [\n"
    "                    \"arbitrary string value\",\n"
    "                    \"arbitrary string value\"\n"
    "                  ],\n"
    "                  \"element4\" : \"arbitrary string value\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element2\" : [\n"
    "                        \"arbitrary string value\",\n"
    "                        \"arbitrary string value\"\n"
    "                      ],\n"
    "                      \"element4\" : \"arbitrary string value\",\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    null,\n"
    "                    null\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                null,\n"
    "                null\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element1\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ],\n"
    "                    \"element2\" : [\n"
    "                      \"arbitrary string value\",\n"
    "                      \"arbitrary string value\"\n"
    "                    ],\n"
    "                    \"element3\" : true,\n"
    "                    \"element4\" : \"arbitrary string value\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element1\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ],\n"
    "                        \"element2\" : [\n"
    "                          \"arbitrary string value\",\n"
    "                          \"arbitrary string value\"\n"
    "                        ],\n"
    "                        \"element3\" : true,\n"
    "                        \"element4\" : \"arbitrary string value\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element1\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ],\n"
    "                            \"element2\" : [\n"
    "                              \"arbitrary string value\",\n"
    "                              \"arbitrary string value\"\n"
    "                            ],\n"
    "                            \"element3\" : true,\n"
    "                            \"element4\" : \"arbitrary string value\",\n"
    "                            \"element6\" : [\n"
    "                              null,\n"
    "                              null\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            null,\n"
    "                            null\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          null,\n"
    "                          null\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        null,\n"
    "                        null\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection1\" : 2\n"
    "                  }\n"
    "                ],\n"
    "                \"element3\" : \"\\/wAB\",\n"
    "                \"element4\" : 2,\n"
    "                \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "                \"element6\" : \"custom\",\n"
    "                \"element7\" : \"LONDON\",\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"arbitrary string value\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : 2,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element14\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element15\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element17\" : [\n"
    "                  2,\n"
    "                  2\n"
    "                ],\n"
    "                \"element18\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ],\n"
    "                \"element19\" : [\n"
    "                  \"custom\",\n"
    "                  \"custom\"\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element4\" : 2,\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : -980123,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element17\" : [\n"
    "            2,\n"
    "            2\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element13\" : [\n"
    "        255,\n"
    "        255\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection1\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ]\n"
    "    },\n"
    "    \"selection6\" : \"\",\n"
    "    \"selection8\" : {\n"
    "      \"selection3\" : {\n"
    "        \"selection3\" : {\n"
    "          \"element1\" : [\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            },\n"
    "            {\n"
    "              \"element1\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ],\n"
    "              \"element2\" : [\n"
    "                \"\",\n"
    "                \"\"\n"
    "              ],\n"
    "              \"element3\" : true,\n"
    "              \"element4\" : \"\",\n"
    "              \"element5\" : {\n"
    "                \"element1\" : {\n"
    "                  \"element1\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ],\n"
    "                  \"element2\" : [\n"
    "                    \"\",\n"
    "                    \"\"\n"
    "                  ],\n"
    "                  \"element3\" : true,\n"
    "                  \"element4\" : \"\",\n"
    "                  \"element5\" : {\n"
    "                    \"element1\" : {\n"
    "                      \"element1\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ],\n"
    "                      \"element2\" : [\n"
    "                        \"\",\n"
    "                        \"\"\n"
    "                      ],\n"
    "                      \"element3\" : true,\n"
    "                      \"element4\" : \"\",\n"
    "                      \"element6\" : [\n"
    "                        \"LONDON\",\n"
    "                        \"LONDON\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element2\" : [\n"
    "                      true,\n"
    "                      true\n"
    "                    ],\n"
    "                    \"element3\" : [\n"
    "                      1.5,\n"
    "                      1.5\n"
    "                    ],\n"
    "                    \"element5\" : [\n"
    "                      null,\n"
    "                      null\n"
    "                    ],\n"
    "                    \"element6\" : [\n"
    "                      \"2012-08-18T13:25:00.000+00:00\",\n"
    "                      \"2012-08-18T13:25:00.000+00:00\"\n"
    "                    ]\n"
    "                  },\n"
    "                  \"element6\" : [\n"
    "                    \"LONDON\",\n"
    "                    \"LONDON\"\n"
    "                  ]\n"
    "                },\n"
    "                \"element2\" : [\n"
    "                  true,\n"
    "                  true\n"
    "                ],\n"
    "                \"element3\" : [\n"
    "                  1.5,\n"
    "                  1.5\n"
    "                ],\n"
    "                \"element5\" : [\n"
    "                  null,\n"
    "                  null\n"
    "                ],\n"
    "                \"element6\" : [\n"
    "                  \"2012-08-18T13:25:00.000+00:00\",\n"
    "                  \"2012-08-18T13:25:00.000+00:00\"\n"
    "                ]\n"
    "              },\n"
    "              \"element6\" : [\n"
    "                \"LONDON\",\n"
    "                \"LONDON\"\n"
    "              ]\n"
    "            }\n"
    "          ],\n"
    "          \"element2\" : [\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            },\n"
    "            {\n"
    "              \"selection3\" : {\n"
    "                \"element1\" : [\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  },\n"
    "                  {\n"
    "                    \"element2\" : [\n"
    "                      \"\",\n"
    "                      \"\"\n"
    "                    ],\n"
    "                    \"element4\" : \"\",\n"
    "                    \"element5\" : {\n"
    "                      \"element1\" : {\n"
    "                        \"element2\" : [\n"
    "                          \"\",\n"
    "                          \"\"\n"
    "                        ],\n"
    "                        \"element4\" : \"\",\n"
    "                        \"element5\" : {\n"
    "                          \"element1\" : {\n"
    "                            \"element2\" : [\n"
    "                              \"\",\n"
    "                              \"\"\n"
    "                            ],\n"
    "                            \"element4\" : \"\",\n"
    "                            \"element6\" : [\n"
    "                              \"LONDON\",\n"
    "                              \"LONDON\"\n"
    "                            ]\n"
    "                          },\n"
    "                          \"element2\" : [\n"
    "                            true,\n"
    "                            true\n"
    "                          ],\n"
    "                          \"element3\" : [\n"
    "                            1.5,\n"
    "                            1.5\n"
    "                          ],\n"
    "                          \"element5\" : [\n"
    "                            -980123,\n"
    "                            -980123\n"
    "                          ],\n"
    "                          \"element6\" : [\n"
    "                            \"2012-08-18T13:25:00.000+00:00\",\n"
    "                            \"2012-08-18T13:25:00.000+00:00\"\n"
    "                          ]\n"
    "                        },\n"
    "                        \"element6\" : [\n"
    "                          \"LONDON\",\n"
    "                          \"LONDON\"\n"
    "                        ]\n"
    "                      },\n"
    "                      \"element2\" : [\n"
    "                        true,\n"
    "                        true\n"
    "                      ],\n"
    "                      \"element3\" : [\n"
    "                        1.5,\n"
    "                        1.5\n"
    "                      ],\n"
    "                      \"element5\" : [\n"
    "                        -980123,\n"
    "                        -980123\n"
    "                      ],\n"
    "                      \"element6\" : [\n"
    "                        \"2012-08-18T13:25:00.000+00:00\",\n"
    "                        \"2012-08-18T13:25:00.000+00:00\"\n"
    "                      ]\n"
    "                    },\n"
    "                    \"element6\" : [\n"
    "                      \"LONDON\",\n"
    "                      \"LONDON\"\n"
    "                    ]\n"
    "                  }\n"
    "                ],\n"
    "                \"element2\" : [\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  },\n"
    "                  {\n"
    "                    \"selection2\" : 1.5\n"
    "                  }\n"
    "                ],\n"
    "                \"element4\" : -980123,\n"
    "                \"element8\" : true,\n"
    "                \"element9\" : \"\",\n"
    "                \"element10\" : 1.5,\n"
    "                \"element11\" : \"\\/wAB\",\n"
    "                \"element12\" : -980123,\n"
    "                \"element13\" : \"LONDON\",\n"
    "                \"element17\" : [\n"
    "                  -980123,\n"
    "                  -980123\n"
    "                ]\n"
    "              }\n"
    "            }\n"
    "          ],\n"
    "          \"element3\" : \"\\/wAB\",\n"
    "          \"element4\" : -980123,\n"
    "          \"element5\" : \"2012-08-18T13:25:00.000+00:00\",\n"
    "          \"element6\" : \"custom\",\n"
    "          \"element7\" : \"LONDON\",\n"
    "          \"element8\" : true,\n"
    "          \"element9\" : \"arbitrary string value\",\n"
    "          \"element10\" : 1.5,\n"
    "          \"element11\" : \"\\/wAB\",\n"
    "          \"element12\" : 2,\n"
    "          \"element13\" : \"LONDON\",\n"
    "          \"element14\" : [\n"
    "            true,\n"
    "            true\n"
    "          ],\n"
    "          \"element15\" : [\n"
    "            1.5,\n"
    "            1.5\n"
    "          ],\n"
    "          \"element17\" : [\n"
    "            -980123,\n"
    "            -980123\n"
    "          ],\n"
    "          \"element18\" : [\n"
    "            \"2012-08-18T13:25:00.000+00:00\",\n"
    "            \"2012-08-18T13:25:00.000+00:00\"\n"
    "          ],\n"
    "          \"element19\" : [\n"
    "            \"custom\",\n"
    "            \"custom\"\n"
    "          ]\n"
    "        }\n"
    "      }\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 0,\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element6\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element10\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        0,\n"
    "        0\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        null,\n"
    "        null\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection2\" : 255,\n"
    "    \"selection6\" : \"arbitrary string value\",\n"
    "    \"selection8\" : {\n"
    "      \"selection4\" : 3123123123\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element1\" : 255,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 255,\n"
    "      \"element6\" : [\n"
    "        999,\n"
    "        999\n"
    "      ],\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element10\" : [\n"
    "        255,\n"
    "        255\n"
    "      ],\n"
    "      \"element15\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection11\" : {\n"
    "    \"selection2\" : 0,\n"
    "    \"selection5\" : true,\n"
    "    \"selection7\" : {\n"
    "      \"element8\" : true,\n"
    "      \"element9\" : \"\",\n"
    "      \"element10\" : 1.5,\n"
    "      \"element11\" : \"\\/wAB\",\n"
    "      \"element12\" : -980123,\n"
    "      \"element13\" : \"LONDON\"\n"
    "    },\n"
    "    \"element4\" : {\n"
    "      \"element2\" : \"custom\",\n"
    "      \"element3\" : 999,\n"
    "      \"element4\" : 3123123123,\n"
    "      \"element5\" : 0,\n"
    "      \"element7\" : \"custom\",\n"
    "      \"element8\" : 999,\n"
    "      \"element9\" : 3123123123,\n"
    "      \"element11\" : [\n"
    "        \"custom\",\n"
    "        \"custom\"\n"
    "      ],\n"
    "      \"element12\" : [\n"
    "        3123123123,\n"
    "        3123123123\n"
    "      ],\n"
    "      \"element13\" : [\n"
    "        null,\n"
    "        null\n"
    "      ],\n"
    "      \"element14\" : [\n"
    "        999,\n"
    "        999\n"
   "      ]\n"
    "    }\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection9\" : {\n"
    "\n"
    "  }\n"
    "}\n",
    "{\n"
    "  \"selection10\" : {\n"
    "    \"element1\" : 3000000000,\n"
    "    \"element2\" : 32794,\n"
    "    \"element3\" : 9223372036854775807\n"
    "  }\n"
    "}\n"
};

const char *FeatureTestMessageUtil::s_XML_MESSAGES[k_NUM_MESSAGES] = {
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element3>\n"
                "      <selection1>true</selection1>\n"
                "    </element3>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection1>\n"
                "        <element1>0</element1>\n"
                "        <element2>custom</element2>\n"
                "        <element3>999</element3>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>0</element5>\n"
                "        <element6/>\n"
                "        <element6/>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element9>3123123123</element9>\n"
                "        <element10>0</element10>\n"
                "        <element10>0</element10>\n"
                "        <element11>custom</element11>\n"
                "        <element11>custom</element11>\n"
                "        <element12>3123123123</element12>\n"
                "        <element12>3123123123</element12>\n"
                "        <element13/>\n"
                "        <element13/>\n"
                "        <element14>999</element14>\n"
                "        <element14>999</element14>\n"
                "        <element15/>\n"
                "        <element15/>\n"
                "      </selection1>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection1>2</selection1>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection1>2</selection1>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection2></selection2>\n"
                "    </element3>\n"
                "    <element5>\n"
                "      <selection1>\n"
                "        <element1>0</element1>\n"
                "        <element2>custom</element2>\n"
                "        <element3>999</element3>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>0</element5>\n"
                "        <element6/>\n"
                "        <element6/>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element9>3123123123</element9>\n"
                "        <element10>0</element10>\n"
                "        <element10>0</element10>\n"
                "        <element11>custom</element11>\n"
                "        <element11>custom</element11>\n"
                "        <element12>3123123123</element12>\n"
                "        <element12>3123123123</element12>\n"
                "        <element13/>\n"
                "        <element13/>\n"
                "        <element14>999</element14>\n"
                "        <element14>999</element14>\n"
                "        <element15/>\n"
                "        <element15/>\n"
                "      </selection1>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection1>\n"
                "        <element1>0</element1>\n"
                "        <element2>custom</element2>\n"
                "        <element3>999</element3>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>0</element5>\n"
                "        <element6/>\n"
                "        <element6/>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element9>3123123123</element9>\n"
                "        <element10>0</element10>\n"
                "        <element10>0</element10>\n"
                "        <element11>custom</element11>\n"
                "        <element11>custom</element11>\n"
                "        <element12>3123123123</element12>\n"
                "        <element12>3123123123</element12>\n"
                "        <element13/>\n"
                "        <element13/>\n"
                "        <element14>999</element14>\n"
                "        <element14>999</element14>\n"
                "        <element15/>\n"
                "        <element15/>\n"
                "      </selection1>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection1>\n"
                "        <element1>255</element1>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>255</element5>\n"
                "        <element6>999</element6>\n"
                "        <element6>999</element6>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element10>255</element10>\n"
                "        <element10>255</element10>\n"
                "        <element13>255</element13>\n"
                "        <element13>255</element13>\n"
                "        <element15>3123123123</element15>\n"
                "        <element15>3123123123</element15>\n"
                "      </selection1>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection2>1.5</selection2>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection2>1.5</selection2>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection2>arbitrary string value</selection2>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection2>1.5</selection2>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection2>1.5</selection2>\n"
                "    </element4>\n"
                "    <element5>\n"
                "      <selection1>\n"
                "        <element1>255</element1>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>255</element5>\n"
                "        <element6>999</element6>\n"
                "        <element6>999</element6>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element10>255</element10>\n"
                "        <element10>255</element10>\n"
                "        <element13>255</element13>\n"
                "        <element13>255</element13>\n"
                "        <element15>3123123123</element15>\n"
                "        <element15>3123123123</element15>\n"
                "      </selection1>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection1>\n"
                "        <element1>255</element1>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>255</element5>\n"
                "        <element6>999</element6>\n"
                "        <element6>999</element6>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element10>255</element10>\n"
                "        <element10>255</element10>\n"
                "        <element13>255</element13>\n"
                "        <element13>255</element13>\n"
                "        <element15>3123123123</element15>\n"
                "        <element15>3123123123</element15>\n"
                "      </selection1>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection1>\n"
                "        <element2>custom</element2>\n"
                "        <element3>999</element3>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>0</element5>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element9>3123123123</element9>\n"
                "        <element11>custom</element11>\n"
                "        <element11>custom</element11>\n"
                "        <element12>3123123123</element12>\n"
                "        <element12>3123123123</element12>\n"
                "        <element13>0</element13>\n"
                "        <element13>0</element13>\n"
                "        <element14>999</element14>\n"
                "        <element14>999</element14>\n"
                "      </selection1>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection3>\n"
                "        <selection1>-980123</selection1>\n"
                "      </selection3>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element5>\n"
                "      <selection1>\n"
                "        <element2>custom</element2>\n"
                "        <element3>999</element3>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>0</element5>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element9>3123123123</element9>\n"
                "        <element11>custom</element11>\n"
                "        <element11>custom</element11>\n"
                "        <element12>3123123123</element12>\n"
                "        <element12>3123123123</element12>\n"
                "        <element13>0</element13>\n"
                "        <element13>0</element13>\n"
                "        <element14>999</element14>\n"
                "        <element14>999</element14>\n"
                "      </selection1>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection1>\n"
                "        <element2>custom</element2>\n"
                "        <element3>999</element3>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>0</element5>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "        <element9>3123123123</element9>\n"
                "        <element11>custom</element11>\n"
                "        <element11>custom</element11>\n"
                "        <element12>3123123123</element12>\n"
                "        <element12>3123123123</element12>\n"
                "        <element13>0</element13>\n"
                "        <element13>0</element13>\n"
                "        <element14>999</element14>\n"
                "        <element14>999</element14>\n"
                "      </selection1>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection2>255</selection2>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>2</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>2</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection3>\n"
                "        <selection1>2</selection1>\n"
                "      </selection3>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>2</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element3>true</element3>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection1>2</selection1>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>2</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element5>\n"
                "      <selection2>255</selection2>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection2>255</selection2>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection2>0</selection2>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element4>-980123</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element4>-980123</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection3>\n"
                "        <selection2>1.5</selection2>\n"
                "      </selection3>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element4>-980123</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5>-980123</element5>\n"
                "            <element5>-980123</element5>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection2>1.5</selection2>\n"
                "        </element2>\n"
                "        <element4>-980123</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element5>\n"
                "      <selection2>0</selection2>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection2>0</selection2>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection3>custom</selection3>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection3>\n"
                "        <selection3>\n"
                "          <element8>true</element8>\n"
                "          <element9></element9>\n"
                "          <element10>1.5</element10>\n"
                "          <element11>FF0001</element11>\n"
                "          <element12>-980123</element12>\n"
                "          <element13>LONDON</element13>\n"
                "        </selection3>\n"
                "      </selection3>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element3>true</element3>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element3>true</element3>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element3>true</element3>\n"
                "                </element1>\n"
                "                <element5>2</element5>\n"
                "                <element5>2</element5>\n"
                "              </element5>\n"
                "            </element1>\n"
                "            <element5>2</element5>\n"
                "            <element5>2</element5>\n"
                "          </element5>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element5>\n"
                "      <selection3>custom</selection3>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection3>custom</selection3>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
#if !defined(BSLS_PLATFORM_OS_WINDOWS)
    // The following strings exceed the maximum string size on Windows
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection4>999</selection4>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element4>2</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element4>2</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection3>\n"
                "        <selection3>\n"
                "          <element1>\n"
                "            <element1>LONDON</element1>\n"
                "            <element1>LONDON</element1>\n"
                "            <element2>arbitrary string value</element2>\n"
                "            <element2>arbitrary string value</element2>\n"
                "            <element3>true</element3>\n"
                "            <element4>arbitrary string value</element4>\n"
                "            <element5>\n"
                "              <element1>\n"
                "                <element1>LONDON</element1>\n"
                "                <element1>LONDON</element1>\n"
                "                <element2>arbitrary string value</element2>\n"
                "                <element2>arbitrary string value</element2>\n"
                "                <element3>true</element3>\n"
                "                <element4>arbitrary string value</element4>\n"
                "                <element5>\n"
                "                  <element1>\n"
                "                    <element1>LONDON</element1>\n"
                "                    <element1>LONDON</element1>\n"
                "                    <element2>arbitrary string value</element2>\n"
                "                    <element2>arbitrary string value</element2>\n"
                "                    <element3>true</element3>\n"
                "                    <element4>arbitrary string value</element4>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element1>\n"
                "                  <element2/>\n"
                "                  <element2/>\n"
                "                  <element3/>\n"
                "                  <element3/>\n"
                "                  <element5/>\n"
                "                  <element5/>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element5>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element1>\n"
                "              <element2/>\n"
                "              <element2/>\n"
                "              <element3/>\n"
                "              <element3/>\n"
                "              <element5/>\n"
                "              <element5/>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element5>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element1>\n"
                "          <element1>\n"
                "            <element1>LONDON</element1>\n"
                "            <element1>LONDON</element1>\n"
                "            <element2>arbitrary string value</element2>\n"
                "            <element2>arbitrary string value</element2>\n"
                "            <element3>true</element3>\n"
                "            <element4>arbitrary string value</element4>\n"
                "            <element5>\n"
                "              <element1>\n"
                "                <element1>LONDON</element1>\n"
                "                <element1>LONDON</element1>\n"
                "                <element2>arbitrary string value</element2>\n"
                "                <element2>arbitrary string value</element2>\n"
                "                <element3>true</element3>\n"
                "                <element4>arbitrary string value</element4>\n"
                "                <element5>\n"
                "                  <element1>\n"
                "                    <element1>LONDON</element1>\n"
                "                    <element1>LONDON</element1>\n"
                "                    <element2>arbitrary string value</element2>\n"
                "                    <element2>arbitrary string value</element2>\n"
                "                    <element3>true</element3>\n"
                "                    <element4>arbitrary string value</element4>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element1>\n"
                "                  <element2/>\n"
                "                  <element2/>\n"
                "                  <element3/>\n"
                "                  <element3/>\n"
                "                  <element5/>\n"
                "                  <element5/>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element5>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element1>\n"
                "              <element2/>\n"
                "              <element2/>\n"
                "              <element3/>\n"
                "              <element3/>\n"
                "              <element5/>\n"
                "              <element5/>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element5>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element1>\n"
                "          <element2>\n"
                "            <selection1>2</selection1>\n"
                "          </element2>\n"
                "          <element2>\n"
                "            <selection1>2</selection1>\n"
                "          </element2>\n"
                "          <element3>FF0001</element3>\n"
                "          <element4>2</element4>\n"
                "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "          <element6>custom</element6>\n"
                "          <element7>LONDON</element7>\n"
                "          <element8>true</element8>\n"
                "          <element9>arbitrary string value</element9>\n"
                "          <element10>1.5</element10>\n"
                "          <element11>FF0001</element11>\n"
                "          <element12>2</element12>\n"
                "          <element13>LONDON</element13>\n"
                "          <element14>true</element14>\n"
                "          <element14>true</element14>\n"
                "          <element15>1.5</element15>\n"
                "          <element15>1.5</element15>\n"
                "          <element17>2</element17>\n"
                "          <element17>2</element17>\n"
                "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "          <element19>custom</element19>\n"
                "          <element19>custom</element19>\n"
                "        </selection3>\n"
                "      </selection3>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element4>2</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element2>arbitrary string value</element2>\n"
                "          <element4>arbitrary string value</element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2/>\n"
                "            <element2/>\n"
                "            <element3/>\n"
                "            <element3/>\n"
                "            <element6/>\n"
                "            <element6/>\n"
                "          </element5>\n"
                "          <element6/>\n"
                "          <element6/>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element2>arbitrary string value</element2>\n"
                "              <element3>true</element3>\n"
                "              <element4>arbitrary string value</element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element2>arbitrary string value</element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4>arbitrary string value</element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element1>LONDON</element1>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element2>arbitrary string value</element2>\n"
                "                      <element3>true</element3>\n"
                "                      <element4>arbitrary string value</element4>\n"
                "                      <element6/>\n"
                "                      <element6/>\n"
                "                    </element1>\n"
                "                    <element2/>\n"
                "                    <element2/>\n"
                "                    <element3/>\n"
                "                    <element3/>\n"
                "                    <element5/>\n"
                "                    <element5/>\n"
                "                    <element6/>\n"
                "                    <element6/>\n"
                "                  </element5>\n"
                "                  <element6/>\n"
                "                  <element6/>\n"
                "                </element1>\n"
                "                <element2/>\n"
                "                <element2/>\n"
                "                <element3/>\n"
                "                <element3/>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6/>\n"
                "                <element6/>\n"
                "              </element5>\n"
                "              <element6/>\n"
                "              <element6/>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection1>2</selection1>\n"
                "            </element2>\n"
                "            <element3>FF0001</element3>\n"
                "            <element4>2</element4>\n"
                "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "            <element6>custom</element6>\n"
                "            <element7>LONDON</element7>\n"
                "            <element8>true</element8>\n"
                "            <element9>arbitrary string value</element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>2</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element14>true</element14>\n"
                "            <element14>true</element14>\n"
                "            <element15>1.5</element15>\n"
                "            <element15>1.5</element15>\n"
                "            <element17>2</element17>\n"
                "            <element17>2</element17>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "            <element19>custom</element19>\n"
                "            <element19>custom</element19>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element4>2</element4>\n"
                "        <element8>true</element8>\n"
                "        <element9></element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>-980123</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element17>2</element17>\n"
                "        <element17>2</element17>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element5>\n"
                "      <selection4>999</selection4>\n"
                "    </element5>\n"
                "    <element5>\n"
                "      <selection4>999</selection4>\n"
                "    </element5>\n"
                "  </selection1>\n"
                "</Obj>\n",
                "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
                "  <selection1>\n"
                "    <element1>\n"
                "      <selection1>\n"
                "        <element4>3123123123</element4>\n"
                "        <element5>255</element5>\n"
                "        <element7>custom</element7>\n"
                "        <element8>999</element8>\n"
                "      </selection1>\n"
                "    </element1>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element4>-980123</element4>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element17>-980123</element17>\n"
                "            <element17>-980123</element17>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element4>-980123</element4>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element17>-980123</element17>\n"
                "            <element17>-980123</element17>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>-980123</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element2>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element4>-980123</element4>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element17>-980123</element17>\n"
                "            <element17>-980123</element17>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element4>-980123</element4>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element17>-980123</element17>\n"
                "            <element17>-980123</element17>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>-980123</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element2>\n"
                "    <element3>\n"
                "      <selection3>\n"
                "        <selection3>\n"
                "          <element1>\n"
                "            <element2></element2>\n"
                "            <element2></element2>\n"
                "            <element4></element4>\n"
                "            <element5>\n"
                "              <element1>\n"
                "                <element2></element2>\n"
                "                <element2></element2>\n"
                "                <element4></element4>\n"
                "                <element5>\n"
                "                  <element1>\n"
                "                    <element2></element2>\n"
                "                    <element2></element2>\n"
                "                    <element4></element4>\n"
                "                    <element6>LONDON</element6>\n"
                "                    <element6>LONDON</element6>\n"
                "                  </element1>\n"
                "                  <element2>true</element2>\n"
                "                  <element2>true</element2>\n"
                "                  <element3>1.5</element3>\n"
                "                  <element3>1.5</element3>\n"
                "                  <element5>-980123</element5>\n"
                "                  <element5>-980123</element5>\n"
                "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                </element5>\n"
                "                <element6>LONDON</element6>\n"
                "                <element6>LONDON</element6>\n"
                "              </element1>\n"
                "              <element2>true</element2>\n"
                "              <element2>true</element2>\n"
                "              <element3>1.5</element3>\n"
                "              <element3>1.5</element3>\n"
                "              <element5>-980123</element5>\n"
                "              <element5>-980123</element5>\n"
                "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            </element5>\n"
                "            <element6>LONDON</element6>\n"
                "            <element6>LONDON</element6>\n"
                "          </element1>\n"
                "          <element1>\n"
                "            <element2></element2>\n"
                "            <element2></element2>\n"
                "            <element4></element4>\n"
                "            <element5>\n"
                "              <element1>\n"
                "                <element2></element2>\n"
                "                <element2></element2>\n"
                "                <element4></element4>\n"
                "                <element5>\n"
                "                  <element1>\n"
                "                    <element2></element2>\n"
                "                    <element2></element2>\n"
                "                    <element4></element4>\n"
                "                    <element6>LONDON</element6>\n"
                "                    <element6>LONDON</element6>\n"
                "                  </element1>\n"
                "                  <element2>true</element2>\n"
                "                  <element2>true</element2>\n"
                "                  <element3>1.5</element3>\n"
                "                  <element3>1.5</element3>\n"
                "                  <element5>-980123</element5>\n"
                "                  <element5>-980123</element5>\n"
                "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                </element5>\n"
                "                <element6>LONDON</element6>\n"
                "                <element6>LONDON</element6>\n"
                "              </element1>\n"
                "              <element2>true</element2>\n"
                "              <element2>true</element2>\n"
                "              <element3>1.5</element3>\n"
                "              <element3>1.5</element3>\n"
                "              <element5>-980123</element5>\n"
                "              <element5>-980123</element5>\n"
                "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            </element5>\n"
                "            <element6>LONDON</element6>\n"
                "            <element6>LONDON</element6>\n"
                "          </element1>\n"
                "          <element2>\n"
                "            <selection2>1.5</selection2>\n"
                "          </element2>\n"
                "          <element2>\n"
                "            <selection2>1.5</selection2>\n"
                "          </element2>\n"
                "          <element4>-980123</element4>\n"
                "          <element8>true</element8>\n"
                "          <element9></element9>\n"
                "          <element10>1.5</element10>\n"
                "          <element11>FF0001</element11>\n"
                "          <element12>-980123</element12>\n"
                "          <element13>LONDON</element13>\n"
                "          <element17>-980123</element17>\n"
                "          <element17>-980123</element17>\n"
                "        </selection3>\n"
                "      </selection3>\n"
                "    </element3>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element4>-980123</element4>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element17>-980123</element17>\n"
                "            <element17>-980123</element17>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element2>\n"
                "          <selection3>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element4></element4>\n"
                "                  <element5>\n"
                "                    <element1>\n"
                "                      <element2></element2>\n"
                "                      <element2></element2>\n"
                "                      <element4></element4>\n"
                "                      <element6>LONDON</element6>\n"
                "                      <element6>LONDON</element6>\n"
                "                    </element1>\n"
                "                    <element2>true</element2>\n"
                "                    <element2>true</element2>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element3>1.5</element3>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element5>-980123</element5>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                  </element5>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5>-980123</element5>\n"
                "                <element5>-980123</element5>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element2>\n"
                "              <selection2>1.5</selection2>\n"
                "            </element2>\n"
                "            <element4>-980123</element4>\n"
                "            <element8>true</element8>\n"
                "            <element9></element9>\n"
                "            <element10>1.5</element10>\n"
                "            <element11>FF0001</element11>\n"
                "            <element12>-980123</element12>\n"
                "            <element13>LONDON</element13>\n"
                "            <element17>-980123</element17>\n"
                "            <element17>-980123</element17>\n"
                "          </selection3>\n"
                "        </element2>\n"
                "        <element3>FF0001</element3>\n"
                "        <element4>-980123</element4>\n"
                "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
                "        <element6>custom</element6>\n"
                "        <element7>LONDON</element7>\n"
                "        <element8>true</element8>\n"
                "        <element9>arbitrary string value</element9>\n"
                "        <element10>1.5</element10>\n"
                "        <element11>FF0001</element11>\n"
                "        <element12>2</element12>\n"
                "        <element13>LONDON</element13>\n"
                "        <element14>true</element14>\n"
                "        <element14>true</element14>\n"
                "        <element15>1.5</element15>\n"
                "        <element15>1.5</element15>\n"
                "        <element17>-980123</element17>\n"
                "        <element17>-980123</element17>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
                "        <element19>custom</element19>\n"
                "        <element19>custom</element19>\n"
                "      </selection3>\n"
                "    </element4>\n"
                "    <element4>\n"
                "      <selection3>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
                "                <element2>true</element2>\n"
                "                <element3>1.5</element3>\n"
                "                <element3>1.5</element3>\n"
                "                <element5/>\n"
                "                <element5/>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "              </element5>\n"
                "              <element6>LONDON</element6>\n"
                "              <element6>LONDON</element6>\n"
                "            </element1>\n"
                "            <element2>true</element2>\n"
                "            <element2>true</element2>\n"
                "            <element3>1.5</element3>\n"
                "            <element3>1.5</element3>\n"
                "            <element5/>\n"
                "            <element5/>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
                "          </element5>\n"
                "          <element6>LONDON</element6>\n"
                "          <element6>LONDON</element6>\n"
                "        </element1>\n"
                "        <element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element1>LONDON</element1>\n"
                "          <element2></element2>\n"
                "          <element2></element2>\n"
                "          <element3>true</element3>\n"
                "          <element4></element4>\n"
                "          <element5>\n"
                "            <element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element1>LONDON</element1>\n"
                "              <element2></element2>\n"
                "              <element2></element2>\n"
                "              <element3>true</element3>\n"
                "              <element4></element4>\n"
                "              <element5>\n"
                "                <element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element1>LONDON</element1>\n"
                "                  <element2></element2>\n"
                "                  <element2></element2>\n"
                "                  <element3>true</element3>\n"
                "                  <element4></element4>\n"
                "                  <element6>LONDON</element6>\n"
                "                  <element6>LONDON</element6>\n"
                "                </element1>\n"
                "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>true</element2>\n"
    "            <element2>true</element2>\n"
    "            <element3>1.5</element3>\n"
    "            <element3>1.5</element3>\n"
    "            <element5/>\n"
    "            <element5/>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          </element5>\n"
    "          <element6>LONDON</element6>\n"
    "          <element6>LONDON</element6>\n"
    "        </element1>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element4>-980123</element4>\n"
    "            <element8>true</element8>\n"
    "            <element9></element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>-980123</element12>\n"
    "            <element13>LONDON</element13>\n"
    "            <element17>-980123</element17>\n"
    "            <element17>-980123</element17>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element4>-980123</element4>\n"
    "            <element8>true</element8>\n"
    "            <element9></element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>-980123</element12>\n"
    "            <element13>LONDON</element13>\n"
    "            <element17>-980123</element17>\n"
    "            <element17>-980123</element17>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element3>FF0001</element3>\n"
    "        <element4>-980123</element4>\n"
    "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "        <element6>custom</element6>\n"
    "        <element7>LONDON</element7>\n"
    "        <element8>true</element8>\n"
    "        <element9>arbitrary string value</element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>2</element12>\n"
    "        <element13>LONDON</element13>\n"
    "        <element14>true</element14>\n"
    "        <element14>true</element14>\n"
    "        <element15>1.5</element15>\n"
    "        <element15>1.5</element15>\n"
    "        <element17>-980123</element17>\n"
    "        <element17>-980123</element17>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element19>custom</element19>\n"
    "        <element19>custom</element19>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>255</element5>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>255</element5>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "  </selection1>\n"
    "</Obj>\n",
#endif
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection1>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection1>true</selection1>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection1>true</selection1>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element3>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection1>true</selection1>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection1>true</selection1>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "  </selection1>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection1>\n"
    "    <element1>\n"
    "      <selection1>\n"
    "        <element1>0</element1>\n"
    "        <element2>custom</element2>\n"
    "        <element3>999</element3>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>0</element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element9>3123123123</element9>\n"
    "        <element10>0</element10>\n"
    "        <element10>0</element10>\n"
    "        <element11>custom</element11>\n"
    "        <element11>custom</element11>\n"
    "        <element12>3123123123</element12>\n"
    "        <element12>3123123123</element12>\n"
    "        <element13/>\n"
    "        <element13/>\n"
    "        <element14>999</element14>\n"
    "        <element14>999</element14>\n"
    "        <element15/>\n"
    "        <element15/>\n"
    "      </selection1>\n"
    "    </element1>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection2></selection2>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection2></selection2>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element3>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element4>2</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection2></selection2>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection2></selection2>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element1>0</element1>\n"
    "        <element2>custom</element2>\n"
    "        <element3>999</element3>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>0</element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element9>3123123123</element9>\n"
    "        <element10>0</element10>\n"
    "        <element10>0</element10>\n"
    "        <element11>custom</element11>\n"
    "        <element11>custom</element11>\n"
    "        <element12>3123123123</element12>\n"
    "        <element12>3123123123</element12>\n"
    "        <element13/>\n"
    "        <element13/>\n"
    "        <element14>999</element14>\n"
    "        <element14>999</element14>\n"
    "        <element15/>\n"
    "        <element15/>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element1>0</element1>\n"
    "        <element2>custom</element2>\n"
    "        <element3>999</element3>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>0</element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element9>3123123123</element9>\n"
    "        <element10>0</element10>\n"
    "        <element10>0</element10>\n"
    "        <element11>custom</element11>\n"
    "        <element11>custom</element11>\n"
    "        <element12>3123123123</element12>\n"
    "        <element12>3123123123</element12>\n"
    "        <element13/>\n"
    "        <element13/>\n"
    "        <element14>999</element14>\n"
    "        <element14>999</element14>\n"
    "        <element15/>\n"
    "        <element15/>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "  </selection1>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection1>\n"
    "    <element1>\n"
    "      <selection1>\n"
    "        <element1>255</element1>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>255</element5>\n"
    "        <element6>999</element6>\n"
    "        <element6>999</element6>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element10>255</element10>\n"
    "        <element10>255</element10>\n"
    "        <element13>255</element13>\n"
    "        <element13>255</element13>\n"
    "        <element15>3123123123</element15>\n"
    "        <element15>3123123123</element15>\n"
    "      </selection1>\n"
    "    </element1>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection2>arbitrary string value</selection2>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection2>arbitrary string value</selection2>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element3>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element3>true</element3>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element3>true</element3>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element3>true</element3>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element3>true</element3>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element4>-980123</element4>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element17>-980123</element17>\n"
    "              <element17>-980123</element17>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element4>-980123</element4>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element17>-980123</element17>\n"
    "              <element17>-980123</element17>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element4>-980123</element4>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element17>-980123</element17>\n"
    "          <element17>-980123</element17>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection2>arbitrary string value</selection2>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection2>arbitrary string value</selection2>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element1>255</element1>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>255</element5>\n"
    "        <element6>999</element6>\n"
    "        <element6>999</element6>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element10>255</element10>\n"
    "        <element10>255</element10>\n"
    "        <element13>255</element13>\n"
    "        <element13>255</element13>\n"
    "        <element15>3123123123</element15>\n"
    "        <element15>3123123123</element15>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element1>255</element1>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>255</element5>\n"
    "        <element6>999</element6>\n"
    "        <element6>999</element6>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element10>255</element10>\n"
    "        <element10>255</element10>\n"
    "        <element13>255</element13>\n"
    "        <element13>255</element13>\n"
    "        <element15>3123123123</element15>\n"
    "        <element15>3123123123</element15>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "  </selection1>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection1>\n"
    "    <element1>\n"
    "      <selection1>\n"
    "        <element2>custom</element2>\n"
    "        <element3>999</element3>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>0</element5>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element9>3123123123</element9>\n"
    "        <element11>custom</element11>\n"
    "        <element11>custom</element11>\n"
    "        <element12>3123123123</element12>\n"
    "        <element12>3123123123</element12>\n"
    "        <element13>0</element13>\n"
    "        <element13>0</element13>\n"
    "        <element14>999</element14>\n"
    "        <element14>999</element14>\n"
    "      </selection1>\n"
    "    </element1>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection3>\n"
    "          <selection1>-980123</selection1>\n"
    "        </selection3>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element2>\n"
    "      <selection4>\n"
    "        <selection3>\n"
    "          <selection1>-980123</selection1>\n"
    "        </selection3>\n"
    "      </selection4>\n"
    "    </element2>\n"
    "    <element3>\n"
    "      <selection4>3123123123</selection4>\n"
    "    </element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection3>\n"
    "          <selection1>-980123</selection1>\n"
    "        </selection3>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection3>\n"
    "          <selection1>-980123</selection1>\n"
    "        </selection3>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element2>custom</element2>\n"
    "        <element3>999</element3>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>0</element5>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element9>3123123123</element9>\n"
    "        <element11>custom</element11>\n"
    "        <element11>custom</element11>\n"
    "        <element12>3123123123</element12>\n"
    "        <element12>3123123123</element12>\n"
    "        <element13>0</element13>\n"
    "        <element13>0</element13>\n"
    "        <element14>999</element14>\n"
    "        <element14>999</element14>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "    <element5>\n"
    "      <selection1>\n"
    "        <element2>custom</element2>\n"
    "        <element3>999</element3>\n"
    "        <element4>3123123123</element4>\n"
    "        <element5>0</element5>\n"
    "        <element7>custom</element7>\n"
    "        <element8>999</element8>\n"
    "        <element9>3123123123</element9>\n"
    "        <element11>custom</element11>\n"
    "        <element11>custom</element11>\n"
    "        <element12>3123123123</element12>\n"
    "        <element12>3123123123</element12>\n"
    "        <element13>0</element13>\n"
    "        <element13>0</element13>\n"
    "        <element14>999</element14>\n"
    "        <element14>999</element14>\n"
    "      </selection1>\n"
    "    </element5>\n"
    "  </selection1>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection1>\n"
    "    <element1>\n"
    "      <selection2>255</selection2>\n"
    "    </element1>\n"
    "    <element2>\n"
    "      <selection1>-980123</selection1>\n"
    "    </element2>\n"
    "    <element2>\n"
    "      <selection1>-980123</selection1>\n"
    "    </element2>\n"
    "    <element3>\n"
    "      <selection1>true</selection1>\n"
    "    </element3>\n"
    "    <element4>\n"
    "      <selection1>-980123</selection1>\n"
    "    </element4>\n"
    "    <element4>\n"
    "      <selection1>-980123</selection1>\n"
    "    </element4>\n"
    "    <element5>\n"
    "      <selection2>255</selection2>\n"
    "    </element5>\n"
    "    <element5>\n"
    "      <selection2>255</selection2>\n"
    "    </element5>\n"
    "  </selection1>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection1>\n"
    "    <element1>\n"
    "      <selection2>0</selection2>\n"
    "    </element1>\n"
    "    <element3>\n"
    "      <selection2></selection2>\n"
    "    </element3>\n"
    "    <element4>\n"
    "      <selection1>2</selection1>\n"
    "    </element4>\n"
    "    <element4>\n"
    "      <selection1>2</selection1>\n"
    "    </element4>\n"
    "    <element5>\n"
    "      <selection2>0</selection2>\n"
    "    </element5>\n"
    "    <element5>\n"
    "      <selection2>0</selection2>\n"
    "    </element5>\n"
    "  </selection1>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection2>FF0001</selection2>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection1>2</selection1>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection2>1.5</selection2>\n"
    "    </element4>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection3>\n"
    "        <element8>true</element8>\n"
    "        <element9></element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>-980123</element12>\n"
    "        <element13>LONDON</element13>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection3>\n"
    "        <element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element3>true</element3>\n"
    "          <element4>arbitrary string value</element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element3>true</element3>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element2/>\n"
    "            <element2/>\n"
    "            <element3/>\n"
    "            <element3/>\n"
    "            <element5/>\n"
    "            <element5/>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element5>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element1>\n"
    "        <element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element3>true</element3>\n"
    "          <element4>arbitrary string value</element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element3>true</element3>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element2/>\n"
    "            <element2/>\n"
    "            <element3/>\n"
    "            <element3/>\n"
    "            <element5/>\n"
    "            <element5/>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element5>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element1>\n"
    "        <element2>\n"
    "          <selection1>2</selection1>\n"
    "        </element2>\n"
    "        <element2>\n"
    "          <selection1>2</selection1>\n"
    "        </element2>\n"
    "        <element3>FF0001</element3>\n"
    "        <element4>2</element4>\n"
    "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "        <element6>custom</element6>\n"
    "        <element7>LONDON</element7>\n"
    "        <element8>true</element8>\n"
    "        <element9>arbitrary string value</element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>2</element12>\n"
    "        <element13>LONDON</element13>\n"
    "        <element14>true</element14>\n"
    "        <element14>true</element14>\n"
    "        <element15>1.5</element15>\n"
    "        <element15>1.5</element15>\n"
    "        <element17>2</element17>\n"
    "        <element17>2</element17>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element19>custom</element19>\n"
    "        <element19>custom</element19>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection3>\n"
    "        <element1>\n"
    "          <element2></element2>\n"
    "          <element2></element2>\n"
    "          <element4></element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>true</element2>\n"
    "            <element2>true</element2>\n"
    "            <element3>1.5</element3>\n"
    "            <element3>1.5</element3>\n"
    "            <element5>-980123</element5>\n"
    "            <element5>-980123</element5>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          </element5>\n"
    "          <element6>LONDON</element6>\n"
    "          <element6>LONDON</element6>\n"
    "        </element1>\n"
    "        <element1>\n"
    "          <element2></element2>\n"
    "          <element2></element2>\n"
    "          <element4></element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>true</element2>\n"
    "            <element2>true</element2>\n"
    "            <element3>1.5</element3>\n"
    "            <element3>1.5</element3>\n"
    "            <element5>-980123</element5>\n"
    "            <element5>-980123</element5>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          </element5>\n"
    "          <element6>LONDON</element6>\n"
    "          <element6>LONDON</element6>\n"
    "        </element1>\n"
    "        <element2>\n"
    "          <selection2>1.5</selection2>\n"
    "        </element2>\n"
    "        <element2>\n"
    "          <selection2>1.5</selection2>\n"
    "        </element2>\n"
    "        <element4>-980123</element4>\n"
    "        <element8>true</element8>\n"
    "        <element9></element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>-980123</element12>\n"
    "        <element13>LONDON</element13>\n"
    "        <element17>-980123</element17>\n"
    "        <element17>-980123</element17>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection3>\n"
    "        <element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element3>true</element3>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element3>true</element3>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element3>true</element3>\n"
    "                </element1>\n"
    "                <element5>2</element5>\n"
    "                <element5>2</element5>\n"
    "              </element5>\n"
    "            </element1>\n"
    "            <element5>2</element5>\n"
    "            <element5>2</element5>\n"
    "          </element5>\n"
    "        </element1>\n"
    "        <element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element3>true</element3>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element3>true</element3>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element3>true</element3>\n"
    "                </element1>\n"
    "                <element5>2</element5>\n"
    "                <element5>2</element5>\n"
    "              </element5>\n"
    "            </element1>\n"
    "            <element5>2</element5>\n"
    "            <element5>2</element5>\n"
    "          </element5>\n"
    "        </element1>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element8>true</element8>\n"
    "            <element9></element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>-980123</element12>\n"
    "            <element13>LONDON</element13>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element8>true</element8>\n"
    "            <element9></element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>-980123</element12>\n"
    "            <element13>LONDON</element13>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element3>FF0001</element3>\n"
    "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "        <element6>custom</element6>\n"
    "        <element7>LONDON</element7>\n"
    "        <element8>true</element8>\n"
    "        <element9>arbitrary string value</element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>2</element12>\n"
    "        <element13>LONDON</element13>\n"
    "        <element14>true</element14>\n"
    "        <element14>true</element14>\n"
    "        <element15>1.5</element15>\n"
    "        <element15>1.5</element15>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element19>custom</element19>\n"
    "        <element19>custom</element19>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection3>\n"
    "        <element1>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element4>arbitrary string value</element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element2/>\n"
    "            <element2/>\n"
    "            <element3/>\n"
    "            <element3/>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element5>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element1>\n"
    "        <element1>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element2>arbitrary string value</element2>\n"
    "          <element4>arbitrary string value</element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element2/>\n"
    "            <element2/>\n"
    "            <element3/>\n"
    "            <element3/>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element5>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element1>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element3>true</element3>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element3>true</element3>\n"
    "                      <element4>arbitrary string value</element4>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element1>\n"
    "                    <element2/>\n"
    "                    <element2/>\n"
    "                    <element3/>\n"
    "                    <element3/>\n"
    "                    <element5/>\n"
    "                    <element5/>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element5>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element3>true</element3>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element3>true</element3>\n"
    "                      <element4>arbitrary string value</element4>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element1>\n"
    "                    <element2/>\n"
    "                    <element2/>\n"
    "                    <element3/>\n"
    "                    <element3/>\n"
    "                    <element5/>\n"
    "                    <element5/>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element5>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element2>\n"
    "              <selection1>2</selection1>\n"
    "            </element2>\n"
    "            <element2>\n"
    "              <selection1>2</selection1>\n"
    "            </element2>\n"
    "            <element3>FF0001</element3>\n"
    "            <element4>2</element4>\n"
    "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "            <element6>custom</element6>\n"
    "            <element7>LONDON</element7>\n"
    "            <element8>true</element8>\n"
    "            <element9>arbitrary string value</element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>2</element12>\n"
    "            <element13>LONDON</element13>\n"
    "            <element14>true</element14>\n"
    "            <element14>true</element14>\n"
    "            <element15>1.5</element15>\n"
    "            <element15>1.5</element15>\n"
    "            <element17>2</element17>\n"
    "            <element17>2</element17>\n"
    "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "            <element19>custom</element19>\n"
    "            <element19>custom</element19>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element3>true</element3>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element3>true</element3>\n"
    "                      <element4>arbitrary string value</element4>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element1>\n"
    "                    <element2/>\n"
    "                    <element2/>\n"
    "                    <element3/>\n"
    "                    <element3/>\n"
    "                    <element5/>\n"
    "                    <element5/>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element5>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element2>arbitrary string value</element2>\n"
    "              <element3>true</element3>\n"
    "              <element4>arbitrary string value</element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element2>arbitrary string value</element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4>arbitrary string value</element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element1>LONDON</element1>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element2>arbitrary string value</element2>\n"
    "                      <element3>true</element3>\n"
    "                      <element4>arbitrary string value</element4>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element1>\n"
    "                    <element2/>\n"
    "                    <element2/>\n"
    "                    <element3/>\n"
    "                    <element3/>\n"
    "                    <element5/>\n"
    "                    <element5/>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element5>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element1>\n"
    "                <element2/>\n"
    "                <element2/>\n"
    "                <element3/>\n"
    "                <element3/>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element5>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element1>\n"
    "            <element2>\n"
    "              <selection1>2</selection1>\n"
    "            </element2>\n"
    "            <element2>\n"
    "              <selection1>2</selection1>\n"
    "            </element2>\n"
    "            <element3>FF0001</element3>\n"
    "            <element4>2</element4>\n"
    "            <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "            <element6>custom</element6>\n"
    "            <element7>LONDON</element7>\n"
    "            <element8>true</element8>\n"
    "            <element9>arbitrary string value</element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>2</element12>\n"
    "            <element13>LONDON</element13>\n"
    "            <element14>true</element14>\n"
    "            <element14>true</element14>\n"
    "            <element15>1.5</element15>\n"
    "            <element15>1.5</element15>\n"
    "            <element17>2</element17>\n"
    "            <element17>2</element17>\n"
    "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "            <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "            <element19>custom</element19>\n"
    "            <element19>custom</element19>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element4>2</element4>\n"
    "        <element8>true</element8>\n"
    "        <element9></element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>-980123</element12>\n"
    "        <element13>LONDON</element13>\n"
    "        <element17>2</element17>\n"
    "        <element17>2</element17>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection3>\n"
    "        <element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element2></element2>\n"
    "          <element2></element2>\n"
    "          <element3>true</element3>\n"
    "          <element4></element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element3>true</element3>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4></element4>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>true</element2>\n"
    "            <element2>true</element2>\n"
    "            <element3>1.5</element3>\n"
    "            <element3>1.5</element3>\n"
    "            <element5/>\n"
    "            <element5/>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          </element5>\n"
    "          <element6>LONDON</element6>\n"
    "          <element6>LONDON</element6>\n"
    "        </element1>\n"
    "        <element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element1>LONDON</element1>\n"
    "          <element2></element2>\n"
    "          <element2></element2>\n"
    "          <element3>true</element3>\n"
    "          <element4></element4>\n"
    "          <element5>\n"
    "            <element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element1>LONDON</element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element3>true</element3>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element1>LONDON</element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element3>true</element3>\n"
    "                  <element4></element4>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5/>\n"
    "                <element5/>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>true</element2>\n"
    "            <element2>true</element2>\n"
    "            <element3>1.5</element3>\n"
    "            <element3>1.5</element3>\n"
    "            <element5/>\n"
    "            <element5/>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          </element5>\n"
    "          <element6>LONDON</element6>\n"
    "          <element6>LONDON</element6>\n"
    "        </element1>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element4>-980123</element4>\n"
    "            <element8>true</element8>\n"
    "            <element9></element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>-980123</element12>\n"
    "            <element13>LONDON</element13>\n"
    "            <element17>-980123</element17>\n"
    "            <element17>-980123</element17>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element2>\n"
    "          <selection3>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element1>\n"
    "              <element2></element2>\n"
    "              <element2></element2>\n"
    "              <element4></element4>\n"
    "              <element5>\n"
    "                <element1>\n"
    "                  <element2></element2>\n"
    "                  <element2></element2>\n"
    "                  <element4></element4>\n"
    "                  <element5>\n"
    "                    <element1>\n"
    "                      <element2></element2>\n"
    "                      <element2></element2>\n"
    "                      <element4></element4>\n"
    "                      <element6>LONDON</element6>\n"
    "                      <element6>LONDON</element6>\n"
    "                    </element1>\n"
    "                    <element2>true</element2>\n"
    "                    <element2>true</element2>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element3>1.5</element3>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element5>-980123</element5>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  </element5>\n"
    "                  <element6>LONDON</element6>\n"
    "                  <element6>LONDON</element6>\n"
    "                </element1>\n"
    "                <element2>true</element2>\n"
    "                <element2>true</element2>\n"
    "                <element3>1.5</element3>\n"
    "                <element3>1.5</element3>\n"
    "                <element5>-980123</element5>\n"
    "                <element5>-980123</element5>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              </element5>\n"
    "              <element6>LONDON</element6>\n"
    "              <element6>LONDON</element6>\n"
    "            </element1>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element2>\n"
    "              <selection2>1.5</selection2>\n"
    "            </element2>\n"
    "            <element4>-980123</element4>\n"
    "            <element8>true</element8>\n"
    "            <element9></element9>\n"
    "            <element10>1.5</element10>\n"
    "            <element11>FF0001</element11>\n"
    "            <element12>-980123</element12>\n"
    "            <element13>LONDON</element13>\n"
    "            <element17>-980123</element17>\n"
    "            <element17>-980123</element17>\n"
    "          </selection3>\n"
    "        </element2>\n"
    "        <element3>FF0001</element3>\n"
    "        <element4>-980123</element4>\n"
    "        <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "        <element6>custom</element6>\n"
    "        <element7>LONDON</element7>\n"
    "        <element8>true</element8>\n"
    "        <element9>arbitrary string value</element9>\n"
    "        <element10>1.5</element10>\n"
    "        <element11>FF0001</element11>\n"
    "        <element12>2</element12>\n"
    "        <element13>LONDON</element13>\n"
    "        <element14>true</element14>\n"
    "        <element14>true</element14>\n"
    "        <element15>1.5</element15>\n"
    "        <element15>1.5</element15>\n"
    "        <element17>-980123</element17>\n"
    "        <element17>-980123</element17>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "        <element19>custom</element19>\n"
    "        <element19>custom</element19>\n"
    "      </selection3>\n"
    "    </element4>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection1>true</selection1>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection2></selection2>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection2>arbitrary string value</selection2>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>255</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection4>\n"
    "        <selection3>\n"
    "          <selection1>-980123</selection1>\n"
    "        </selection3>\n"
    "      </selection4>\n"
    "    </element4>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection3>\n"
    "    <element1>custom</element1>\n"
    "    <element2>0</element2>\n"
    "    <element3>2012-08-18T13:25:00.000+00:00</element3>\n"
    "    <element4>\n"
    "      <selection1>-980123</selection1>\n"
    "    </element4>\n"
    "    <element5>1.5</element5>\n"
    "  </selection3>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection4/>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection4>\n"
    "    <element1>LONDON</element1>\n"
    "    <element1>LONDON</element1>\n"
    "    <element2>arbitrary string value</element2>\n"
    "    <element2>arbitrary string value</element2>\n"
    "    <element3>true</element3>\n"
    "    <element4>arbitrary string value</element4>\n"
    "    <element5>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element3>true</element3>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element2/>\n"
    "      <element2/>\n"
    "      <element3/>\n"
    "      <element3/>\n"
    "      <element5/>\n"
    "      <element5/>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "    </element5>\n"
    "    <element6/>\n"
    "    <element6/>\n"
    "  </selection4>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection4>\n"
    "    <element2></element2>\n"
    "    <element2></element2>\n"
    "    <element4></element4>\n"
    "    <element5>\n"
    "      <element1>\n"
    "        <element2></element2>\n"
    "        <element2></element2>\n"
    "        <element4></element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>true</element2>\n"
    "          <element2>true</element2>\n"
    "          <element3>1.5</element3>\n"
    "          <element3>1.5</element3>\n"
    "          <element5>-980123</element5>\n"
    "          <element5>-980123</element5>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "        </element5>\n"
    "        <element6>LONDON</element6>\n"
    "        <element6>LONDON</element6>\n"
    "      </element1>\n"
    "      <element2>true</element2>\n"
    "      <element2>true</element2>\n"
    "      <element3>1.5</element3>\n"
    "      <element3>1.5</element3>\n"
    "      <element5>-980123</element5>\n"
    "      <element5>-980123</element5>\n"
    "      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "    </element5>\n"
    "    <element6>LONDON</element6>\n"
    "    <element6>LONDON</element6>\n"
    "  </selection4>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection4>\n"
    "    <element1>LONDON</element1>\n"
    "    <element1>LONDON</element1>\n"
    "    <element3>true</element3>\n"
    "    <element5>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element3>true</element3>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "          </element1>\n"
    "          <element5>2</element5>\n"
    "          <element5>2</element5>\n"
    "        </element5>\n"
    "      </element1>\n"
    "      <element5>2</element5>\n"
    "      <element5>2</element5>\n"
    "    </element5>\n"
    "  </selection4>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection4>\n"
    "    <element2>arbitrary string value</element2>\n"
    "    <element2>arbitrary string value</element2>\n"
    "    <element4>arbitrary string value</element4>\n"
    "    <element5>\n"
    "      <element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element2/>\n"
    "      <element2/>\n"
    "      <element3/>\n"
    "      <element3/>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "    </element5>\n"
    "    <element6/>\n"
    "    <element6/>\n"
    "  </selection4>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection5>2012-08-18T13:25:00.000+00:00</selection5>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection6>custom</selection6>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection7>LONDON</selection7>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "    </selection1>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection1>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </selection1>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection1>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </selection1>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </selection1>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection2>255</selection2>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection2>0</selection2>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection3>custom</selection3>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection8>\n"
    "    <selection4>999</selection4>\n"
    "  </selection8>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "    </selection1>\n"
    "    <selection5>true</selection5>\n"
    "    <element4>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </selection1>\n"
    "    <selection6></selection6>\n"
    "    <selection7>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element3>true</element3>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element3>true</element3>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element2>\n"
    "        <selection1>2</selection1>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection1>2</selection1>\n"
    "      </element2>\n"
    "      <element3>FF0001</element3>\n"
    "      <element4>2</element4>\n"
    "      <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "      <element6>custom</element6>\n"
    "      <element7>LONDON</element7>\n"
    "      <element8>true</element8>\n"
    "      <element9>arbitrary string value</element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>2</element12>\n"
    "      <element13>LONDON</element13>\n"
    "      <element14>true</element14>\n"
    "      <element14>true</element14>\n"
    "      <element15>1.5</element15>\n"
    "      <element15>1.5</element15>\n"
    "      <element17>2</element17>\n"
    "      <element17>2</element17>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element19>custom</element19>\n"
    "      <element19>custom</element19>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </selection1>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection7>\n"
    "      <element1>\n"
    "        <element2></element2>\n"
    "        <element2></element2>\n"
    "        <element4></element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>true</element2>\n"
    "          <element2>true</element2>\n"
    "          <element3>1.5</element3>\n"
    "          <element3>1.5</element3>\n"
    "          <element5>-980123</element5>\n"
    "          <element5>-980123</element5>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "        </element5>\n"
    "        <element6>LONDON</element6>\n"
    "        <element6>LONDON</element6>\n"
    "      </element1>\n"
    "      <element1>\n"
    "        <element2></element2>\n"
    "        <element2></element2>\n"
    "        <element4></element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>true</element2>\n"
    "          <element2>true</element2>\n"
    "          <element3>1.5</element3>\n"
    "          <element3>1.5</element3>\n"
    "          <element5>-980123</element5>\n"
    "          <element5>-980123</element5>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "        </element5>\n"
    "        <element6>LONDON</element6>\n"
    "        <element6>LONDON</element6>\n"
    "      </element1>\n"
    "      <element2>\n"
    "        <selection2>1.5</selection2>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection2>1.5</selection2>\n"
    "      </element2>\n"
    "      <element4>-980123</element4>\n"
    "      <element8>true</element8>\n"
    "      <element9></element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>-980123</element12>\n"
    "      <element13>LONDON</element13>\n"
    "      <element17>-980123</element17>\n"
    "      <element17>-980123</element17>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </selection1>\n"
    "    <selection5>true</selection5>\n"
    "    <selection7>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element3>true</element3>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element5>2</element5>\n"
    "          <element5>2</element5>\n"
    "        </element5>\n"
    "      </element1>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element3>true</element3>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element5>2</element5>\n"
    "          <element5>2</element5>\n"
    "        </element5>\n"
    "      </element1>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element3>FF0001</element3>\n"
    "      <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "      <element6>custom</element6>\n"
    "      <element7>LONDON</element7>\n"
    "      <element8>true</element8>\n"
    "      <element9>arbitrary string value</element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>2</element12>\n"
    "      <element13>LONDON</element13>\n"
    "      <element14>true</element14>\n"
    "      <element14>true</element14>\n"
    "      <element15>1.5</element15>\n"
    "      <element15>1.5</element15>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element19>custom</element19>\n"
    "      <element19>custom</element19>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection2>255</selection2>\n"
    "    <selection6></selection6>\n"
    "    <selection7>\n"
    "      <element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection1>2</selection1>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection1>2</selection1>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element4>2</element4>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection1>2</selection1>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection1>2</selection1>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element4>2</element4>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element4>2</element4>\n"
    "      <element8>true</element8>\n"
    "      <element9></element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>-980123</element12>\n"
    "      <element13>LONDON</element13>\n"
    "      <element17>2</element17>\n"
    "      <element17>2</element17>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection2>0</selection2>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection7>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2></element2>\n"
    "        <element2></element2>\n"
    "        <element3>true</element3>\n"
    "        <element4></element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element3>true</element3>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element3>true</element3>\n"
    "                <element4></element4>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>true</element2>\n"
    "          <element2>true</element2>\n"
    "          <element3>1.5</element3>\n"
    "          <element3>1.5</element3>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "        </element5>\n"
    "        <element6>LONDON</element6>\n"
    "        <element6>LONDON</element6>\n"
    "      </element1>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2></element2>\n"
    "        <element2></element2>\n"
    "        <element3>true</element3>\n"
    "        <element4></element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element3>true</element3>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element3>true</element3>\n"
    "                <element4></element4>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>true</element2>\n"
    "          <element2>true</element2>\n"
    "          <element3>1.5</element3>\n"
    "          <element3>1.5</element3>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "          <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "        </element5>\n"
    "        <element6>LONDON</element6>\n"
    "        <element6>LONDON</element6>\n"
    "      </element1>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection2>1.5</selection2>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection2>1.5</selection2>\n"
    "          </element2>\n"
    "          <element4>-980123</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>-980123</element17>\n"
    "          <element17>-980123</element17>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection2>1.5</selection2>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection2>1.5</selection2>\n"
    "          </element2>\n"
    "          <element4>-980123</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>-980123</element17>\n"
    "          <element17>-980123</element17>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element3>FF0001</element3>\n"
    "      <element4>-980123</element4>\n"
    "      <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "      <element6>custom</element6>\n"
    "      <element7>LONDON</element7>\n"
    "      <element8>true</element8>\n"
    "      <element9>arbitrary string value</element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>2</element12>\n"
    "      <element13>LONDON</element13>\n"
    "      <element14>true</element14>\n"
    "      <element14>true</element14>\n"
    "      <element15>1.5</element15>\n"
    "      <element15>1.5</element15>\n"
    "      <element17>-980123</element17>\n"
    "      <element17>-980123</element17>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element19>custom</element19>\n"
    "      <element19>custom</element19>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection3>custom</selection3>\n"
    "    <selection5>true</selection5>\n"
    "    <selection7>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element8>true</element8>\n"
    "      <element9></element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>-980123</element12>\n"
    "      <element13>LONDON</element13>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection4>999</selection4>\n"
    "    <selection6></selection6>\n"
    "    <selection7>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element3>true</element3>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element1>LONDON</element1>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element2>arbitrary string value</element2>\n"
    "        <element3>true</element3>\n"
    "        <element4>arbitrary string value</element4>\n"
    "        <element5>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2/>\n"
    "          <element2/>\n"
    "          <element3/>\n"
    "          <element3/>\n"
    "          <element5/>\n"
    "          <element5/>\n"
    "          <element6/>\n"
    "          <element6/>\n"
    "        </element5>\n"
    "        <element6/>\n"
    "        <element6/>\n"
    "      </element1>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element4>2</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element2>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element4>2</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "        </selection3>\n"
    "      </element2>\n"
    "      <element3>FF0001</element3>\n"
    "      <element4>2</element4>\n"
    "      <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "      <element6>custom</element6>\n"
    "      <element7>LONDON</element7>\n"
    "      <element8>true</element8>\n"
    "      <element9>arbitrary string value</element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>2</element12>\n"
    "      <element13>LONDON</element13>\n"
    "      <element14>true</element14>\n"
    "      <element14>true</element14>\n"
    "      <element15>1.5</element15>\n"
    "      <element15>1.5</element15>\n"
    "      <element17>2</element17>\n"
    "      <element17>2</element17>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "      <element19>custom</element19>\n"
    "      <element19>custom</element19>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "    </selection1>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection8>\n"
    "      <selection1>true</selection1>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </selection1>\n"
    "    <selection5>true</selection5>\n"
    "    <selection8>\n"
    "      <selection2></selection2>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </selection1>\n"
    "    <selection6></selection6>\n"
    "    <selection8>\n"
    "      <selection2>arbitrary string value</selection2>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </selection1>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection1>-980123</selection1>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection2>255</selection2>\n"
    "    <selection5>true</selection5>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection1>2</selection1>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection2>0</selection2>\n"
    "    <selection6></selection6>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection2>1.5</selection2>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection3>custom</selection3>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection4>999</selection4>\n"
    "    <selection5>true</selection5>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element3>true</element3>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection1>2</selection1>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection1>2</selection1>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element4>2</element4>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "    </selection1>\n"
    "    <selection6></selection6>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5>-980123</element5>\n"
    "              <element5>-980123</element5>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection2>1.5</selection2>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection2>1.5</selection2>\n"
    "          </element2>\n"
    "          <element4>-980123</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>-980123</element17>\n"
    "          <element17>-980123</element17>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </selection1>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element3>true</element3>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element3>true</element3>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element3>true</element3>\n"
    "                  </element1>\n"
    "                  <element5>2</element5>\n"
    "                  <element5>2</element5>\n"
    "                </element5>\n"
    "              </element1>\n"
    "              <element5>2</element5>\n"
    "              <element5>2</element5>\n"
    "            </element5>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </selection1>\n"
    "    <selection5>true</selection5>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element2>arbitrary string value</element2>\n"
    "            <element4>arbitrary string value</element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2/>\n"
    "              <element2/>\n"
    "              <element3/>\n"
    "              <element3/>\n"
    "              <element6/>\n"
    "              <element6/>\n"
    "            </element5>\n"
    "            <element6/>\n"
    "            <element6/>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element2>arbitrary string value</element2>\n"
    "                <element3>true</element3>\n"
    "                <element4>arbitrary string value</element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element2>arbitrary string value</element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4>arbitrary string value</element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element1>LONDON</element1>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element2>arbitrary string value</element2>\n"
    "                        <element3>true</element3>\n"
    "                        <element4>arbitrary string value</element4>\n"
    "                        <element6/>\n"
    "                        <element6/>\n"
    "                      </element1>\n"
    "                      <element2/>\n"
    "                      <element2/>\n"
    "                      <element3/>\n"
    "                      <element3/>\n"
    "                      <element5/>\n"
    "                      <element5/>\n"
    "                      <element6/>\n"
    "                      <element6/>\n"
    "                    </element5>\n"
    "                    <element6/>\n"
    "                    <element6/>\n"
    "                  </element1>\n"
    "                  <element2/>\n"
    "                  <element2/>\n"
    "                  <element3/>\n"
    "                  <element3/>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6/>\n"
    "                  <element6/>\n"
    "                </element5>\n"
    "                <element6/>\n"
    "                <element6/>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection1>2</selection1>\n"
    "              </element2>\n"
    "              <element3>FF0001</element3>\n"
    "              <element4>2</element4>\n"
    "              <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "              <element6>custom</element6>\n"
    "              <element7>LONDON</element7>\n"
    "              <element8>true</element8>\n"
    "              <element9>arbitrary string value</element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>2</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element14>true</element14>\n"
    "              <element14>true</element14>\n"
    "              <element15>1.5</element15>\n"
    "              <element15>1.5</element15>\n"
    "              <element17>2</element17>\n"
    "              <element17>2</element17>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "              <element19>custom</element19>\n"
    "              <element19>custom</element19>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element4>2</element4>\n"
    "          <element8>true</element8>\n"
    "          <element9></element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>-980123</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element17>2</element17>\n"
    "          <element17>2</element17>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element13>255</element13>\n"
    "      <element13>255</element13>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </selection1>\n"
    "    <selection6></selection6>\n"
    "    <selection8>\n"
    "      <selection3>\n"
    "        <selection3>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element3>true</element3>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element3>true</element3>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element1>LONDON</element1>\n"
    "            <element2></element2>\n"
    "            <element2></element2>\n"
    "            <element3>true</element3>\n"
    "            <element4></element4>\n"
    "            <element5>\n"
    "              <element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element1>LONDON</element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element3>true</element3>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element1>LONDON</element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element3>true</element3>\n"
    "                    <element4></element4>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5/>\n"
    "                  <element5/>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>true</element2>\n"
    "              <element2>true</element2>\n"
    "              <element3>1.5</element3>\n"
    "              <element3>1.5</element3>\n"
    "              <element5/>\n"
    "              <element5/>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "              <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "            </element5>\n"
    "            <element6>LONDON</element6>\n"
    "            <element6>LONDON</element6>\n"
    "          </element1>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element4>-980123</element4>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element17>-980123</element17>\n"
    "              <element17>-980123</element17>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element2>\n"
    "            <selection3>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element1>\n"
    "                <element2></element2>\n"
    "                <element2></element2>\n"
    "                <element4></element4>\n"
    "                <element5>\n"
    "                  <element1>\n"
    "                    <element2></element2>\n"
    "                    <element2></element2>\n"
    "                    <element4></element4>\n"
    "                    <element5>\n"
    "                      <element1>\n"
    "                        <element2></element2>\n"
    "                        <element2></element2>\n"
    "                        <element4></element4>\n"
    "                        <element6>LONDON</element6>\n"
    "                        <element6>LONDON</element6>\n"
    "                      </element1>\n"
    "                      <element2>true</element2>\n"
    "                      <element2>true</element2>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element3>1.5</element3>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element5>-980123</element5>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                      <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                    </element5>\n"
    "                    <element6>LONDON</element6>\n"
    "                    <element6>LONDON</element6>\n"
    "                  </element1>\n"
    "                  <element2>true</element2>\n"
    "                  <element2>true</element2>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element3>1.5</element3>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element5>-980123</element5>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                  <element6>2012-08-18T13:25:00.000+00:00</element6>\n"
    "                </element5>\n"
    "                <element6>LONDON</element6>\n"
    "                <element6>LONDON</element6>\n"
    "              </element1>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element2>\n"
    "                <selection2>1.5</selection2>\n"
    "              </element2>\n"
    "              <element4>-980123</element4>\n"
    "              <element8>true</element8>\n"
    "              <element9></element9>\n"
    "              <element10>1.5</element10>\n"
    "              <element11>FF0001</element11>\n"
    "              <element12>-980123</element12>\n"
    "              <element13>LONDON</element13>\n"
    "              <element17>-980123</element17>\n"
    "              <element17>-980123</element17>\n"
    "            </selection3>\n"
    "          </element2>\n"
    "          <element3>FF0001</element3>\n"
    "          <element4>-980123</element4>\n"
    "          <element5>2012-08-18T13:25:00.000+00:00</element5>\n"
    "          <element6>custom</element6>\n"
    "          <element7>LONDON</element7>\n"
    "          <element8>true</element8>\n"
    "          <element9>arbitrary string value</element9>\n"
    "          <element10>1.5</element10>\n"
    "          <element11>FF0001</element11>\n"
    "          <element12>2</element12>\n"
    "          <element13>LONDON</element13>\n"
    "          <element14>true</element14>\n"
    "          <element14>true</element14>\n"
    "          <element15>1.5</element15>\n"
    "          <element15>1.5</element15>\n"
    "          <element17>-980123</element17>\n"
    "          <element17>-980123</element17>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element18>2012-08-18T13:25:00.000+00:00</element18>\n"
    "          <element19>custom</element19>\n"
    "          <element19>custom</element19>\n"
    "        </selection3>\n"
    "      </selection3>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>0</element1>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element6/>\n"
    "      <element6/>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element10>0</element10>\n"
    "      <element10>0</element10>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13>0</element13>\n"
    "      <element13>0</element13>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "      <element15/>\n"
    "      <element15/>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection2>255</selection2>\n"
    "    <selection6>arbitrary string value</selection6>\n"
    "    <selection8>\n"
    "      <selection4>3123123123</selection4>\n"
    "    </selection8>\n"
    "    <element4>\n"
    "      <element1>255</element1>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>255</element5>\n"
    "      <element6>999</element6>\n"
    "      <element6>999</element6>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element10>255</element10>\n"
    "      <element10>255</element10>\n"
    "      <element15>3123123123</element15>\n"
    "      <element15>3123123123</element15>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection11>\n"
    "    <selection2>0</selection2>\n"
    "    <selection5>true</selection5>\n"
    "    <selection7>\n"
    "      <element8>true</element8>\n"
    "      <element9></element9>\n"
    "      <element10>1.5</element10>\n"
    "      <element11>FF0001</element11>\n"
    "      <element12>-980123</element12>\n"
    "      <element13>LONDON</element13>\n"
    "    </selection7>\n"
    "    <element4>\n"
    "      <element2>custom</element2>\n"
    "      <element3>999</element3>\n"
    "      <element4>3123123123</element4>\n"
    "      <element5>0</element5>\n"
    "      <element7>custom</element7>\n"
    "      <element8>999</element8>\n"
    "      <element9>3123123123</element9>\n"
    "      <element11>custom</element11>\n"
    "      <element11>custom</element11>\n"
    "      <element12>3123123123</element12>\n"
    "      <element12>3123123123</element12>\n"
    "      <element13/>\n"
    "      <element13/>\n"
    "      <element14>999</element14>\n"
    "      <element14>999</element14>\n"
    "    </element4>\n"
    "  </selection11>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection9/>\n"
    "</Obj>\n",
    "<Obj xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'>\n"
    "  <selection10>\n"
    "    <element1>3000000000</element1>\n"
    "    <element2>32794</element2>\n"
    "    <element3>9223372036854775807</element3>\n"
    "  </selection10>\n"
    "</Obj>\n"
};

}  // close package namespace
}  // close enterprse namespace

// ----------------------------------------------------------------------------
// Copyright 2020 Bloomberg Finance L.P.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ----------------------------- END-OF-FILE ----------------------------------
